{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit vritransfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls,
  Forms, Dialogs, Gauges, ComCtrls,
  StdCtrls, Buttons,
  ExtCtrls, Db, Math, DBTables;

type
  TTransformer = class(TForm)
    Panel1: TPanel;
    TransCloseBtn: TBitBtn;
    TransHelpBtn: TBitBtn;
    PageControl1: TPageControl;
    DLGImportTS: TTabSheet;
    DLGViewTS: TTabSheet;
    THints: TPanel;
    DLGFileEdit: TEdit;
    DLGImportBtn: TSpeedButton;
    DLGMemo: TMemo;
    DXFNameEdit: TEdit;
    DXFLayerEdit: TEdit;
    DXFLineWidthRG: TRadioGroup;
    DLGDXFExportBtn: TSpeedButton;
    ShapeNameEdit: TEdit;
    ShapeLayerEdit: TEdit;
    DLGShapeExportBtn: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    DLGOpenDialog: TOpenDialog;
    QuickViewEdit: TEdit;
    QuickDLGViewFileBtn: TSpeedButton;
    QuickViewMemo: TMemo;
    Panel3: TPanel;
    QuickViewImage: TImage;
    ScaleEdit: TEdit;
    Label11: TLabel;
    PointIn: TEdit;
    PointOut: TEdit;
    AreaIn: TEdit;
    AreaOut: TEdit;
    LineIn: TEdit;
    LineOut: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    DILineIn: TEdit;
    DILineOut: TEdit;
    Label15: TLabel;
    DIAreaIn: TEdit;
    DIAreaOut: TEdit;
    Label16: TLabel;
    DIPointIn: TEdit;
    DIPointOut: TEdit;
    Label17: TLabel;
    DIScale: TEdit;
    Label18: TLabel;
    DLGIRG: TRadioGroup;
    DLGDate: TEdit;
    DLGName: TEdit;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label37: TLabel;
    DLGNameEdit: TEdit;
    Label38: TLabel;
    DLGDateEdit: TEdit;
    Label39: TLabel;
    Label40: TLabel;
    dbAttTable: TTable;
    dbAttSource: TDataSource;
    DLGMinorCodesCB: TCheckBox;
    USDANRCSTS: TTabSheet;
    NRINatsgoPointsBtn: TSpeedButton;
    NatsgoPdataEdit: TEdit;
    StatsgoEdit: TEdit;
    StateStatsgoBtn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    Label3: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    MaxShapeIslandsEdit: TEdit;
    Label34: TLabel;
    DLGAttSymCB: TCheckBox;
    MaxShapeAttEdit: TEdit;
    TotalPointsaddedEdit: TEdit;
    ShapeViewerTS: TTabSheet;
    ShapeViewEditFileName: TEdit;
    ShapeViewOpen: TSpeedButton;
    Panel2: TPanel;
    ShapeViewImage: TImage;
    ShapeViewMemo: TMemo;
    ShapeViewEditLnP: TEdit;
    ShapeViewEditFileDone: TEdit;
    ShapeViewEditFile: TEdit;
    ShapeViewEditArP: TEdit;
    Label41: TLabel;
    ShapeViewEditPtP: TEdit;
    Label43: TLabel;
    Label44: TLabel;
    Label47: TLabel;
    DLGSkipFirstCB: TCheckBox;
    DLGSingleCodeCB: TCheckBox;
    StatsgoShapeEdit: TEdit;
    NatsgoPShapeEdit: TEdit;
    NRINatsgoPointsBtnShape: TSpeedButton;
    StateStatsgoBtnShape: TSpeedButton;
    Label35: TLabel;
    NRINatsgoPointsBtnGO: TBitBtn;
    StateStatsgoBtnGO: TBitBtn;
    Bevel4: TBevel;
    Bevel6: TBevel;
    DatatoTextFileBox: TCheckBox;
    DLGNumberItemsCB: TCheckBox;
    ShapeEditTS: TTabSheet;
    Label45: TLabel;
    Label46: TLabel;
    Label48: TLabel;
    NatsgodataEdit: TEdit;
    NRIDataBtn: TSpeedButton;
    NatsgoShapeEdit: TEdit;
    NRIShapeBtn: TSpeedButton;
    NRIGOBtn: TBitBtn;
    TotalLinePointsaddedEdit: TEdit;
    Label49: TLabel;
    PickALineEdit1: TEdit;
    PickALineEdit2: TEdit;
    PickALineBtn: TSpeedButton;
    Label50: TLabel;
    IAttPEdit: TEdit;
    IAttLEdit: TEdit;
    IAttAEdit: TEdit;
    Label51: TLabel;
    AttAEdit: TEdit;
    AttLEdit: TEdit;
    AttPEdit: TEdit;
    Label52: TLabel;
    DLGVAreaEdit: TEdit;
    Label53: TLabel;
    NRIPointEdit: TLabel;
    Label54: TLabel;
    nNRIPointEdit: TLabel;
    DLGShapeExportDIRBtn: TSpeedButton;
    AddMapAttributesCB: TCheckBox;
    Label42: TLabel;
    Edit3: TEdit;
    ShapeCombineExportBtn: TSpeedButton;
    ShapeFileEdit1: TEdit;
    ShapeFileSelectorBtn1: TSpeedButton;
    ShapeObjectsEdit1: TEdit;
    Label55: TLabel;
    ShapeFileEdit2: TEdit;
    ShapeFileSelectorBtn2: TSpeedButton;
    ShapeObjectsEdit2: TEdit;
    Label60: TLabel;
    Label61: TLabel;
    ShapeObjectsEdit3: TEdit;
    Label64: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    DlgPathLabel: TLabel;
    ShapePathLabel: TLabel;
    DLGGauge: TProgressBar;
    SkipSsurgoBlankHalfCB: TCheckBox;
    SsurgoSpecialFeatureCB: TCheckBox;
    Label4: TLabel;
    ShapeViewerRG: TRadioGroup;
    TDLGViewHelpBtn: TSpeedButton;
    TDLGImportHelpBtn: TSpeedButton;
    TNRCSdbHelpBtn: TSpeedButton;
    TShapeViewHelpBtn: TSpeedButton;
    ShapeCombineHelp: TSpeedButton;
    SCImport1RG: TRadioGroup;
    SCImport2RG: TRadioGroup;
    SCExportRG: TRadioGroup;
    TabSheet1: TTabSheet;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ShapeShifterHelpBtn: TSpeedButton;
    TabSheet3: TTabSheet;
    SundryImporterHelpBtn: TSpeedButton;
    Label10: TLabel;
    ImportImageLocationsBtn: TSpeedButton;
    ImportPersonsImageAddressBtn: TSpeedButton;
    ImportObjectArealImageBtn: TSpeedButton;
    ImportDataCoverageBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    function RunTimeDbCreate(const DatabaseName, SessionName:
      string): TDatabase;
    function RunTimeDbCreateP(const DatabaseName, SessionName:
      string): TDatabase;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TransCloseBtnClick(Sender: TObject);
    procedure TransHelpBtnClick(Sender: TObject);
    procedure QuickDLGViewFileBtnClick(Sender: TObject);
    procedure DLGImportBtnClick(Sender: TObject);
    procedure DLGDXFExportBtnClick(Sender: TObject);
    procedure DLGShapeExportBtnClick(Sender: TObject);
    procedure MakeDLGImage;
    procedure DLGIRGClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);

    procedure TDLGViewHelpBtnClick(Sender: TObject);
    procedure TDLGImportHelpBtnClick(Sender: TObject);
    procedure TNRCSdbHelpBtnClick(Sender: TObject);

    procedure TShapeViewHelpBtnClick(Sender: TObject);

    procedure ShapeViewOpenClick(Sender: TObject);
    procedure DLGSingleCodeCBClick(Sender: TObject);
    procedure DLGMinorCodesCBClick(Sender: TObject);
    procedure NRINatsgoPointsBtnClick(Sender: TObject);
    procedure NRINatsgoPointsBtnShapeClick(Sender: TObject);
    procedure NRINatsgoPointsBtnGOClick(Sender: TObject);
    procedure StateStatsgoBtnClick(Sender: TObject);
    procedure StateStatsgoBtnShapeClick(Sender: TObject);
    procedure StateStatsgoBtnGOClick(Sender: TObject);
    procedure NRIGOBtnClick(Sender: TObject);
    procedure PickALineBtnClick(Sender: TObject);
    procedure NRIDataBtnClick(Sender: TObject);
    procedure NRIShapeBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShapeCombineHelpClick(Sender: TObject);
    procedure DLGShapeExportDIRBtnClick(Sender: TObject);
    procedure DLGAttSymCBClick(Sender: TObject);

procedure ShapeFileTypeRG(Which: Integer);
    procedure ShapeShifterHelpBtnClick(Sender: TObject);
    procedure SundryImporterHelpBtnClick(Sender: TObject);
    procedure ImportImageLocationsBtnClick(Sender: TObject);
    procedure ImportPersonsImageAddressBtnClick(Sender: TObject);
    procedure ImportObjectArealImageBtnClick(Sender: TObject);
    procedure ImportDataCoverageBtnClick(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Transformer: TTransformer;
  bDLGSelected, DLGhasCrReturns, DLGhasLinefeeds: Boolean;
  Points, Lines, Areas: Integer;
  MyPDatabase, MyDatabase: array[0..10] of TDatabase;
  OutByteArray: array[0..3] of Byte;
  ShapeByte: Byte;
  MyPDbCount, MyDbCount: Integer;


implementation

{$R *.DFM}
uses LoGlobals, LOResMess, vritransoil;

(*
procedure SwapInteger(Incoming: Integer) {:Integer};
var ByteArray: array[0..3] of Byte;
begin
  Move(Incoming, ByteArray, sizeof(ByteArray));
  OutByteArray[3] := ByteArray[0];
  OutByteArray[2] := ByteArray[1];
  OutByteArray[1] := ByteArray[2];
  OutByteArray[0] := ByteArray[3];
end;*)


{---------------------------------------------------------------------}

function TTransformer.RunTimeDbCreate(
  const DatabaseName, SessionName: string): TDatabase;
var
  TempDatabase: TDatabase;
begin
  TempDatabase := nil;
  try
    { If the session exists, make it active; if not, create a new session }
    Sessions.OpenSession(SessionName);
    with Sessions do
      with FindSession(SessionName) do begin
        Result := FindDatabase(DatabaseName);
        if (Result = nil) then begin
          { Create a new database component }
          TempDatabase := TDatabase.Create(Self);
          TempDatabase.DatabaseName :=
            {'sshift' + IntToStr(MyDbCount)} DatabaseName;
          TempDatabase.SessionName := SessionName;
          ConfigMode := cmSession;
          try
            AddStandardAlias(DatabaseName, ShapePath, 'DBASE');
          finally
            ConfigMode := cmAll;
            TempDatabase.KeepConnection := False; {True;}
          end; {finally}
        end; {Result}
        Result := OpenDatabase(DatabaseName);
      end;
  except
    TempDatabase.Free;
    raise;
  end;
end;

function TTransformer.RunTimeDbCreateP(const DatabaseName,
  SessionName: string): TDatabase;
var
  TempDatabase: TDatabase;
begin
  TempDatabase := nil;
  try
    { If the session exists, make it active; if not, create a new session }
    Sessions.OpenSession(SessionName);
    with Sessions do
      with FindSession(SessionName) do begin
        Result := FindDatabase(DatabaseName);
        if (Result = nil) then begin
          { Create a new database component }
          TempDatabase := TDatabase.Create(Self);
          TempDatabase.DatabaseName :=
            {'natsgo' + IntToStr(MyPDbCount)} DatabaseName;
          TempDatabase.SessionName := SessionName;
          ConfigMode := cmSession;
          try
            AddStandardAlias(DatabaseName, ShapePath, 'Paradox'
              {'DBASE'});
          finally
            ConfigMode := cmAll;
            TempDatabase.KeepConnection := False; {True;}
          end; {finally}
        end; {Result}
        Result := OpenDatabase(DatabaseName);
      end;
  except
    TempDatabase.Free;
    raise;
  end;
end;
{---------------------------------------------------------------------}

procedure TTransformer.FormShow(Sender: TObject);
begin
  DLGhasLinefeeds := False;
  THints.Caption := 'File Transformer Progress Hints';
end;

procedure TTransformer.FormCreate(Sender: TObject);
begin
  MyDbCount := 0;
  MyPDBCount := 0;
  bDLGSelected := False;
  top := transfrmY;
  left := transfrmX;
end;

procedure TTransformer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  transfrmY := Transformer.top;
  transfrmX := Transformer.left;
end;

procedure TTransformer.TransCloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TTransformer.TransHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8000);
end;

procedure TTransformer.TDLGViewHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8010);
end;

procedure TTransformer.TDLGImportHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8100);
end;

procedure TTransformer.TNRCSdbHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8200);
end;


procedure TTransformer.TShapeViewHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8300);
end;
procedure TTransformer.ShapeCombineHelpClick(Sender: TObject);
begin
  Application.HelpContext(8400);
end;

procedure TTransformer.ShapeShifterHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8500);
end;

procedure TTransformer.SundryImporterHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8600);
end;
{---------------------------------------------------------------------}



{---------------------------------------------------------------------}
{Get File name, etc... IF BMP exists then display else...
Check Radio Groups Check File data CR/LF
Read DLG... Display into Bitmap}

procedure TTransformer.QuickDLGViewFileBtnClick(Sender: TObject);
var
{  F1,DxfOutFile:TextFile;}
{  ErrorCode,i,ii:Integer;
In2String,LCol, RCol,TRow,BRow,  InString:String;}
  Bitmap: TBitmap;
  TempNameS, TempNameS2, TempExt, temp: string;
{RecordLength,  DlgFormat, DlgScale:integer; }
begin
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'DLG data|*.DLG;*.*f;*.OPT';
  DLGOpenDialog.InitialDir := DLGPath;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then
  begin
    THints.Caption := 'DLG File Display';
    DLGGauge.Position := 10;
    DLGPath := ExtractFilePath(DLGOpenDialog.filename);

    TempExt := Uppercase(ExtractFileExt(DLGOpenDialog.filename));
    if ((TempExt[4] = 'F') and
      (DLGOpenDialog.filename[length(DLGOpenDialog.filename) - 7] <>
        '-')) then
    begin
      temp := ExtractFileName(DLGOpenDialog.filename);
      temp[length(temp) - 3] := '-';
      TempName := DLGPath + temp + '.dlg';{TempExt;}
      if (not RenameFile(DLGOpenDialog.filename, TempName)) then
        DoRezError(3) else
      begin
      {Rename other file}
        TempNameS := DLGOpenDialog.filename;
        TempNameS[length(TempNameS)] := 'a';
        if FileExists(TempNameS) then
        begin
          temp := ExtractFileName(TempNameS);
          temp[length(temp) - 3] := '-';
          TempExt := lowercase(ExtractFileExt(TempNameS));
          TempNameS2 := DLGPath + temp + TempExt;
          {rename dlg to attribute}
          TempNameS2[length(TempNameS2)] := 'a';
          if (not RenameFile(TempNameS, TempNameS2)) then
            DoRezError(3);
        end; {Fileexists}
      end; {Rename}
    end else TempName := DLGOpenDialog.filename;

{Whatever starts here}
    temp := ExtractFileName(TempName {DLGOpenDialog.filename});
    QuickViewEdit.Text := temp;
   {If BMP Image exists then display}
    temp := TempName {DLGOpenDialog.filename};
    temp := ChangeFileExt(temp, '.BMP');
    if (FileExists(temp)) then
    begin
      Bitmap := TBitmap.Create;
      Bitmap.Width := 313;
      Bitmap.Height := 313;
      QuickViewImage.Picture.Graphic := Bitmap;
      QuickViewImage.Picture.LoadFromFile(temp);
      Bitmap.Free;
  {else Make it,Display it, Save it}
    end else MakeDLGImage;
    DLGGauge.Position := 0;
  end;
end;

procedure TTransformer.MakeDLGImage;
var
  F1: TextFile; DLGBlockIn: file;
  InBuf: array[0..79] of char;
  DLGDone, Linefeeds: Boolean; Ch: Char;
  ScaleString, In2String, temp3, temp2, temp, InString: string;
  Bitmap: TBitmap;
  ShapeAttributePN, MaxShapeAttributePN,
    PointCount, NumberLines, Number, Oddpoints, CountDracula,
    Count3, CountOdd, AreaCount, LineCount, CountLines,
{Points, Lines, Areas,} ErrorCode, i, ii,
    Count, ErrorCodex, ErrorCodey,
    RecordLength, DlgFormat, DlgScale, DlgScaleCheck,
{DlgFormatIndex,} DlgScaleIndex: integer;
  XShift, YShift, Ratio, xdiff, ydiff,
  dXMIN,dYMIN,dXMAX,dYMAX,dXTemp,dYTemp: Double;
begin {}
  QuickViewMemo.Lines.Clear;
{   DlgFormatIndex:=QuickViewFormatRG.ItemIndex;}
  AssignFile(F1, TempName {DLGOpenDialog.Filename});
  Reset(F1);
{Check Header }
  DLGhasLinefeeds := False;
  DLGhasCrReturns := False;
  for i := 1 to 170 do begin Read(F1, Ch);
   {These names are reversed I think?}
    if (ord(Ch) = 10) then DLGhasCrReturns := True;
    if (ord(Ch) = 13) then DLGhasLinefeeds := True; end;
  if ((DLGhasCrReturns) and (not DLGhasLinefeeds)) then begin
    DLGhasLinefeeds := False;
    CloseFile(F1);
    AssignFile(DLGBlockIn, TempName {DLGOpenDialog.Filename});
    Reset(DLGBlockIn, 1); {Cause it has a lF but no CR}
  end else begin
    if (DLGhasLinefeeds) then
      begin DLGhasCrReturns := False; Reset(F1) end else
    begin CloseFile(F1); AssignFile(DLGBlockIn, TempName
      {DLGOpenDialog.Filename});
      Reset(DLGBlockIn, 80) end; end;

{Get the first line... Banner}
  if (DLGhasCrReturns) then begin
    InString := ''; Ch := 'a';
    while (ord(Ch) <> 10) do begin
      BlockRead(DLGBlockIn, Ch, 1);
      InString := InString + Ch; end; end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
  QuickViewMemo.Lines.Add(InString);

{Get Scale}
  if (DLGhasCrReturns) then begin
    InString := ''; Ch := 'a';
    while (ord(Ch) <> 10) do begin
      BlockRead(DLGBlockIn, Ch, 1);
      InString := InString + Ch; end; end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
  QuickViewMemo.Lines.Add(InString);
  ScaleString := Copy(InString, 53, 7); {53..60}
  val(ScaleString, DlgScaleCheck, Errorcode);
  str(DlgScaleCheck, ScaleString);
  ScaleEdit.Text := ScaleString;
  ScaleString := Copy(InString, 42, 9); {42..51}
  val(ScaleString, DlgScaleCheck, Errorcode);
  str(DlgScaleCheck, ScaleString);
  DLGDate.Text := ScaleString;
  ScaleString := Copy(InString, 1, 40); {1..40}
  ScaleString := trim(ScaleString);
  DLGName.Text := ScaleString;

{Read past the header not used at this time}
  for i := 1 to 8 do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    QuickViewMemo.Lines.Add(InString);
  end;
{Get the Corners}
  if (DLGhasCrReturns) then begin
    InString := ''; Ch := 'a';
    while (ord(Ch) <> 10) do begin
      BlockRead(DLGBlockIn, Ch, 1);
      InString := InString + Ch; end; end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
  QuickViewMemo.Lines.Add(InString);
  dYMIN := 0;dXMIN := 0;  {Compiler shutup}
  temp := Copy(InString, 37, 11);
  Val(temp, dXTemp, ErrorCode);
  if ErrorCode = 0 then
  begin
    dXMAX := dXTemp;
    dXMIN := dXTemp;
  end else DoRezError(9);
  temp := Copy(InString, 49, 11);
  Val(temp, dYTemp, ErrorCode);
  if ErrorCode = 0 then begin
    dYMAX := dYTemp;
    dYMIN := dYTemp;
  end else DoRezError(10);
  for i := 1 to 3 do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    QuickViewMemo.Lines.Add(InString);
    temp := Copy(InString, 37, 11);
    Val(temp, dXTemp, ErrorCode);
    if ErrorCode = 0 then begin
      if dXTemp > dXMAX then dXMAX := dXTemp;
      if dXTemp < dXMIN then dXMIN := dXTemp;
    end else DoRezError(9);
    temp := Copy(InString, 49, 11);
    Val(temp, dYTemp, ErrorCode);
    if ErrorCode = 0 then begin
      if dYTemp > dYMAX then dYMAX := dYTemp;
      if dYTemp < dYMIN then dYMIN := dYTemp;
    end else DoRezError(10);
  end;
{Set screen area}
  xdiff := abs(dXMAX - dXMIN);
  ydiff := Abs(dYMAX - dYMIN);
  if (xdiff > ydiff) then Ratio := (xdiff / 312) else
    Ratio := (ydiff / 312);
  if dXMIN < 0 then begin XShift := abs(dXMIN) end
  else if dXMIN > 0 then XShift := (0 - dXMIN) else XShift := 0;
  if dYMIN < 0 then begin YShift := abs(dYMIN) end
  else if dYMIN > 0 then YShift := (0 - dYMIN) else YShift := 0;

{str(XMIN,temp);
str(XMAX,temp2);
   Message Dlg('X Min '+temp+' max '+temp2, mtInformation,[mbOk], 0);
str(YMIN,temp);
str(YMAX,temp2);
   Message Dlg('Y Min '+temp+' max '+temp2, mtInformation,[mbOk], 0);
}

{Get the DLG type, and number of points, areas, lines}
  if (DLGhasCrReturns) then begin
    InString := ''; Ch := 'a';
    while (ord(Ch) <> 10) do begin
      BlockRead(DLGBlockIn, Ch, 1);
      InString := InString + Ch; end; end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
  QuickViewMemo.Lines.Add(InString);
  temp := Copy(InString, 31, 6);
  Val(temp, Points, ErrorCode);
  if ErrorCode <> 0 then halt;
  temp2 := Copy(InString, 47, 6);
  Val(temp2, Areas, ErrorCode);
  if ErrorCode <> 0 then halt;
  temp3 := Copy(InString, 63, 6);
  Val(temp3, Lines, ErrorCode);
  if ErrorCode <> 0 then halt;
  THints.Caption := 'Points ' + temp + ' Areas ' + temp2 + ' Lines '
    + temp3;
  PointIn.Text := temp;
  AreaIn.Text := temp2;
  LineIn.Text := temp3;

  Bitmap := TBitmap.Create;
  Bitmap.Width := 313;
  Bitmap.Height := 313;
  QuickViewImage.Picture.Graphic := Bitmap;
{Bitmap.Free;  Freed at end...}
  Application.ProcessMessages;

{Read in Points}
  PointCount := 0;
  MaxShapeAttributePN := 0;
  repeat begin
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
      if InString[1] = 'N' then begin {Get number of points per line}
        inc(PointCount);
        temp := Copy(InString, 49, 6);
        Val(temp, ShapeAttributePN, ErrorCodex);
        if (ErrorCodex > 0) then Codefx(temp, ErrorCodex) else
          if (ShapeAttributePN > MaxShapeAttributePN) then
            MaxShapeAttributePN := (ShapeAttributePN);
      end;
    end;
    if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
      DLGDone := EOF(DLGBlockIn);
  until ((PointCount > 3) or (DLGDone));
  str(MaxShapeAttributePN, temp);
  AttPEdit.Text := temp;
  MaxShapeAttributePN := 0;
{Read in Areas}
  AreaCount := 0;
  while (AreaCount < 2) do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    if (InString[1] = 'A') then begin
      inc(AreaCount);
      temp := Copy(InString, 49, 6);
      Val(temp, ShapeAttributePN, ErrorCodex);
      if (ErrorCodex > 0) then Codefx(temp, ErrorCodex) else
        if (ShapeAttributePN > MaxShapeAttributePN) then
          MaxShapeAttributePN := (ShapeAttributePN);
      for CountLines := 1 to 15 do begin
        if (DLGhasCrReturns) then begin
          InString := ''; Ch := 'a';
          while (ord(Ch) <> 10) do begin
            BlockRead(DLGBlockIn, Ch, 1);
            InString := InString + Ch; end; end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else begin
            BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
        QuickViewMemo.Lines.Add(InString);
      end;
    end;
  end;
  str(MaxShapeAttributePN, temp);
  AttAEdit.Text := temp;
  MaxShapeAttributePN := 0;
{Read in Lines}
  QuickViewImage.Canvas.Pen.Width := 1;
  QuickViewImage.Canvas.Pen.Color := ClBlack;
  QuickViewImage.Canvas.Pen.Style := psSolid;
  DLGGauge.Position := 0;
  LineCount := 0; Count := 0;
{For Count := 1 to Lines}
  DLGDone := False;
{  If (DLGhasLinefeeds) then DLGDone:=EOF(F1) else DLGDone:=EOF(DLGBlockIn);}
  while ((not DLGDone) and (LineCount < (Lines))) do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
      DLGDone := EOF(DLGBlockIn);
    inc(Count);
    DLGGauge.Position := (Count div (Lines div 100));
    if InString[1] = 'L' then begin {Get number of points per line}
      Application.ProcessMessages;
      temp := Copy(InString, 3, 6);
      temp2 := trim(temp);
      Val(temp2, CountDracula, ErrorCode);
      temp := Copy(InString, 42, 8); {42+8=50?}
      temp2 := trim(temp);
      Val(temp2, Number, ErrorCode);
      if (ErrorCode = 0) then begin
        inc(LineCount);
        if (LineCount <> CountDracula) then
        begin
          str(Linecount, temp);
          MessageDlgPos('Lines are maligned at ' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
          LineCount := CountDracula;
        end;
        NumberLines := Number div 3;
        Oddpoints := Number mod 3;
        temp := Copy(InString, 49, 6);
        Val(temp, ShapeAttributePN, ErrorCodex);
        if (ErrorCodex > 0) then Codefx(temp, ErrorCodex) else
          if (ShapeAttributePN > MaxShapeAttributePN) then
            MaxShapeAttributePN := (ShapeAttributePN);
  {Process the points into a line}
        if NumberLines > 0 then begin
          for CountLines := 1 to NumberLines do begin
            if (DLGhasCrReturns) then begin
              InString := ''; Ch := 'a';
              while (ord(Ch) <> 10) do begin
                BlockRead(DLGBlockIn, Ch, 1);
                InString := InString + Ch; end; end else
              if (DLGhasLinefeeds) then Readln(F1, InString) else
                begin
                BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                  end;
            temp := Copy(InString, 1, 12); temp := trim(temp);
            Val(temp, dXTemp, ErrorCodex);
            temp2 := Copy(InString, 13, 12); temp2 := trim(temp2);
            Val(temp2, dYTemp, ErrorCodey);
            if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
              dXTemp := dXTemp + XShift; dYTemp := dYTemp + YShift;
              i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                Ratio));
              QuickViewImage.Canvas.MoveTo(i, 312 - ii);
            end else
              MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
            { MessageDlgPos('Lines are maligned at ' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);}
            for Count3 := 1 to 3 do begin
              temp := Copy(InString, (1 + (24 * (Count3 - 1))), 12);
                temp := trim(temp);
              Val(temp, dXTemp, ErrorCodex);
              temp2 := Copy(InString, (13 + (24 * (Count3 - 1))),
                12); temp2 := trim(temp2);
              Val(temp2, dYTemp, ErrorCodey);
              if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                dXTemp := dXTemp + XShift; dYTemp := dYTemp + YShift;
                i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                  Ratio));
                QuickViewImage.Canvas.LineTo(i, 312 - ii);
              end else
              MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
            end;
          end;
        end;
        if (Oddpoints > 0) then begin
          if (DLGhasCrReturns) then begin
            InString := ''; Ch := 'a';
            while (ord(Ch) <> 10) do begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch; end; end else
            if (DLGhasLinefeeds) then Readln(F1, InString) else begin
              BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                end;
          if (NumberLines < 1) then
            begin {Just make a start if it is a short line}
            temp := Copy(InString, 1, 12); temp := trim(temp);
            Val(temp, dXTemp, ErrorCodex);
            temp2 := Copy(InString, 13, 12); temp2 := trim(temp2);
            Val(temp2, dYTemp, ErrorCodey);
            if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
              dXTemp := dXTemp + XShift; dYTemp := dYTemp + YShift;
              i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                Ratio));
              QuickViewImage.Canvas.MoveTo(i, 312 - ii);
            end;
          end;
          for CountOdd := 1 to Oddpoints do begin
            temp := Copy(InString, (1 + (24 * (CountOdd - 1))), 12);
              temp := trim(temp);
            Val(temp, dXTemp, ErrorCodex);
            temp2 := Copy(InString, (13 + (24 * (CountOdd - 1))),
              12); temp2 := trim(temp2);
            Val(temp2, dYTemp, ErrorCodey);
            if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
              dXTemp := dXTemp + XShift; dYTemp := dYTemp + YShift;
              i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                Ratio));
   {Make the Line} QuickViewImage.Canvas.LineTo(i, 312 - ii);
            end;
          end;
        end;
      end else
              MessageDlgPos('Points this Line WRONG' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
      if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
        DLGDone := EOF(DLGBlockIn);
    end; {if 'L'}
  end; {of lines}
  if (DLGhasLinefeeds) then CloseFile(F1) else CloseFile(DLGBlockIn);
  DLGGauge.Position := 0;
  str(MaxShapeAttributePN, temp);
  AttLEdit.Text := temp;
  str(LineCount, temp2);
   {Message Dlg('Number of Lines Read '+temp2, mtInformation,[mbOk], 0);}
  THints.Caption := 'Number of Lines Read ' + temp2;
  LineOut.Text := temp2;
  temp := DLGOpenDialog.filename;
  temp := ChangeFileExt(temp, '.BMP');
{leave out till it works}
  QuickViewImage.Picture.SaveToFile(temp);
  Bitmap.Free;
{end else  Message Dlg('File MUST have linefeeds', mtInformation,[mbOk], 0);}
  Application.ProcessMessages;
end;
(*******************************************************************)

(*******************************************************************)
{Display selected Line(s) in Blue... Red colors
PickALineEdit1 Starting line
PickALineEdit2 Finishing line}

procedure TTransformer.PickALineBtnClick(Sender: TObject);
var
  F1: TextFile; DLGBlockIn: file;
  InBuf: array[1..80] of char;
  DLGDone, Linefeeds: Boolean; Ch: Char;
  temp2, temp, InString: string;
  Bitmap: TBitmap; ColorCounter: Byte;
  NumberLines, Number, Oddpoints, Count3, CountOdd, CountLines,
    ErrorCode, i, ii, Count, ErrorCodex, ErrorCodey, AreaCount,
    PickArea, Startingline, Finishingline: integer;
      dXMIN,dYMIN,dXMAX,dYMAX,dXTemp,dYTemp,
  XShift, YShift, Ratio, xdiff, ydiff: Double;
begin {}
  AssignFile(F1, DLGOpenDialog.Filename);
  Reset(F1);
{Check Header }
  DLGhasLinefeeds := False;
  DLGhasCrReturns := False;
  for i := 1 to 170 do begin Read(F1, Ch);
    if (ord(Ch) = 10) then DLGhasCrReturns := True;
    if (ord(Ch) = 13) then DLGhasLinefeeds := True; end;
  if ((DLGhasCrReturns) and (not DLGhasLinefeeds)) then begin
    DLGhasLinefeeds := False;
    CloseFile(F1);
    AssignFile(DLGBlockIn, DLGOpenDialog.Filename);
    Reset(DLGBlockIn, 1); {Cause it has a lF but no CR}
  end else begin
    if (DLGhasLinefeeds) then
      begin DLGhasCrReturns := False; Reset(F1) end else
    begin CloseFile(F1); AssignFile(DLGBlockIn,
      DLGOpenDialog.Filename);
      Reset(DLGBlockIn, 80) end; end;


  ColorCounter := 123;
{Read past the header not used at this time}
  for i := 1 to 10 do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end; end;

  if (DLGhasCrReturns) then begin
    InString := ''; Ch := 'a';
    while (ord(Ch) <> 10) do begin
      BlockRead(DLGBlockIn, Ch, 1);
      InString := InString + Ch; end; end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
  temp := Copy(InString, 37, 11);
  Val(temp, dXTemp, ErrorCode);
  dYMIN := 0;dXMIN := 0;   dYMAX := 0;dXMAX := 0; {Compiler shutup}
  if ErrorCode = 0 then begin
    dXMAX := dXTemp;
    dXMIN := dXTemp;
  end else DoRezError(9);
  temp := Copy(InString, 49, 11);
  Val(temp, dYTemp, ErrorCode);
  if ErrorCode = 0 then begin
    dYMAX := dYTemp;
    dYMIN := dYTemp;
  end else DoRezError(10);
  for i := 1 to 3 do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    temp := Copy(InString, 37, 11);
    Val(temp, dXTemp, ErrorCode);

    if ErrorCode = 0 then begin
      if dXTemp > dXMAX then dXMAX := dXTemp;
      if dXTemp < dXMIN then dXMIN := dXTemp;
    end else DoRezError(9);
    temp := Copy(InString, 49, 11);
    Val(temp, dYTemp, ErrorCode);
    if ErrorCode = 0 then begin
      if dYTemp > dYMAX then dYMAX := dYTemp;
      if dYTemp < dYMIN then dYMIN := dYTemp;
    end else DoRezError(10);
  end;
{Set screen area}
  xdiff := abs(dXMAX - dXMIN);
  ydiff := Abs(dYMAX - dYMIN);
  if (xdiff > ydiff) then Ratio := (xdiff / 312) else
    Ratio := (ydiff / 312);
  if dXMIN < 0 then begin XShift := abs(dXMIN) end
  else if dXMIN > 0 then XShift := (0 - dXMIN) else XShift := 0;
  if dYMIN < 0 then begin YShift := abs(dYMIN) end
  else if dYMIN > 0 then YShift := (0 - dYMIN) else YShift := 0;
  Bitmap := TBitmap.Create;
  Bitmap.Width := 313;
  Bitmap.Height := 313;
  QuickViewImage.Picture.Graphic := Bitmap;
  QuickViewImage.Canvas.Pen.Width := 1;
  QuickViewImage.Canvas.Pen.Color := RGB(255, 255, ColorCounter);
  QuickViewImage.Canvas.Pen.Style := psSolid;
  Application.ProcessMessages;

{Read in Lines}
  Val(PickALineEdit1.Text, Startingline, ErrorCode);
  Val(PickALineEdit2.Text, Finishingline, ErrorCode);
  Val(DLGVAreaEdit.Text, PickArea, ErrorCode);

  DLGGauge.Position := 0;
  AreaCount := 0; Count := 0;

  if (DLGhasLinefeeds) then Reset(F1) else
    if (DLGhasCrReturns) then Reset(DLGBlockIn, 1)
    else Reset(DLGBlockIn, 80);
  DLGDone := False;
  while ((not DLGDone)) do begin
    if (DLGhasCrReturns) then begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch; end; end else
      if (DLGhasLinefeeds) then Readln(F1, InString) else begin
        BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    if InString[1] = 'A' then begin {Get number of line in the area}
      inc(AreaCount);
      if (AreaCount = PickArea) then begin
   {Put the lines numbers into Memo}
        for CountLines := 1 to 15 do begin
          if (DLGhasCrReturns) then begin
            InString := ''; Ch := 'a';
            while (ord(Ch) <> 10) do begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch; end; end else
            if (DLGhasLinefeeds) then Readln(F1, InString) else begin
              BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                end;
          QuickViewMemo.Lines.Add(InString);
        end;
      end;
    end else {Not an area so check lines}
      if InString[1] = 'L' then begin {Get number of points per line}
        inc(Count);
        ColorCounter := 123;
        if ((Count >= Startingline) and (Count <= Finishingline)) then
          begin
          temp := Copy(InString, 42, 8);
          temp2 := trim(temp);
          Val(temp2, Number, ErrorCode);
          if (ErrorCode = 0) then begin
            NumberLines := Number div 3;
            Oddpoints := Number mod 3;
  {Process the points into a line}
            if NumberLines > 0 then begin
              for CountLines := 1 to NumberLines do begin
                if (DLGhasCrReturns) then begin
                  InString := ''; Ch := 'a';
                  while (ord(Ch) <> 10) do begin
                    BlockRead(DLGBlockIn, Ch, 1);
                    InString := InString + Ch; end; end else
                  if (DLGhasLinefeeds) then Readln(F1, InString) else
                    begin
                    BlockRead(DLGBlockIn, InBuf, 1); InString :=
                      InBuf; end;
                temp := Copy(InString, 1, 12); temp := trim(temp);
                Val(temp, dXTemp, ErrorCodex);
                temp2 := Copy(InString, 13, 12); temp2 :=
                  trim(temp2);
                Val(temp2, dYTemp, ErrorCodey);
                if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                  dXTemp := dXTemp + XShift; dYTemp := dYTemp +
                    YShift;
                  i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                    Ratio));
                  QuickViewImage.Canvas.MoveTo(i, 312 - ii);
                end else
                  MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);

                for Count3 := 1 to 3 do begin
                  temp := Copy(InString, (1 + (24 * (Count3 - 1))),
                    12); temp := trim(temp);
                  Val(temp, dXTemp, ErrorCodex);
                  temp2 := Copy(InString, (13 + (24 * (Count3 - 1))),
                    12); temp2 := trim(temp2);
                  Val(temp2, dYTemp, ErrorCodey);
                  if ((ErrorCodex = 0) and (ErrorCodey = 0)) then
                    begin
                    dXTemp := dXTemp + XShift; dYTemp := dYTemp +
                      YShift;
                    i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp
                      / Ratio));
                    QuickViewImage.Canvas.Pen.Color := RGB(255, 255,
                      (ColorCounter + Round((Number / 100) * Count)));
                    QuickViewImage.Canvas.LineTo(i, 312 - ii);
                  end else
                  MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
                end;
              end;
            end;
            if (Oddpoints > 0) then begin
              if (DLGhasCrReturns) then begin
                InString := ''; Ch := 'a';
                while (ord(Ch) <> 10) do begin
                  BlockRead(DLGBlockIn, Ch, 1);
                  InString := InString + Ch; end; end else
                if (DLGhasLinefeeds) then Readln(F1, InString) else
                  begin
                  BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                    end;
              if (NumberLines < 1) then
                begin {Just make a start if it is a short line}
                temp := Copy(InString, 1, 12); temp := trim(temp);
                Val(temp, dXTemp, ErrorCodex);
                temp2 := Copy(InString, 13, 12); temp2 :=
                  trim(temp2);
                Val(temp2, dYTemp, ErrorCodey);
                if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                  dXTemp := dXTemp + XShift; dYTemp := dYTemp +
                    YShift;
                  i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                    Ratio));
                  QuickViewImage.Canvas.MoveTo(i, 312 - ii);
                end;
              end;
              for CountOdd := 1 to Oddpoints do begin
                temp := Copy(InString, (1 + (24 * (CountOdd - 1))),
                  12); temp := trim(temp);
                Val(temp, dXTemp, ErrorCodex);
                temp2 := Copy(InString, (13 + (24 * (CountOdd - 1))),
                  12); temp2 := trim(temp2);
                Val(temp2, dYTemp, ErrorCodey);
                if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                  dXTemp := dXTemp + XShift; dYTemp := dYTemp +
                    YShift;
                  i := trunc((dXTemp / Ratio)); ii := trunc((dYTemp /
                    Ratio));
                  QuickViewImage.Canvas.Pen.Color := RGB(255, 255,
                    (ColorCounter + Round((Number / 100) * Count)));
                  QuickViewImage.Canvas.LineTo(i, 312 - ii);
                end;
              end;
            end;
          end;
        end;
      end; {if 'L'}
    if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
      DLGDone := EOF(DLGBlockIn);
  end; {of lines}
  if (DLGhasLinefeeds) then CloseFile(F1) else CloseFile(DLGBlockIn);
  Bitmap.Free;
{end else  Message Dlg('File MUST have linefeeds', mtInformation,[mbOk], 0);}
end;

(*******************************************************************)
(***************************************************************)


(********************************************************************)
(********************************************************************)
(*****************************************************************)

procedure TTransformer.PageControl1Change(Sender: TObject);
begin
  DLGhasLinefeeds := False;
end;
(******************************************************************)
(******************************************************************)

procedure TTransformer.DLGImportBtnClick(Sender: TObject);
var
  DLGBlockIn: file;
  F1: TextFile; Ch: Char;
  InBuf: array[1..80] of char;
  TempExt,TempNameS,TempNameS2,
  ScaleString, {In2String,} temp3, temp2, temp1, temp, InString:
    string;
{DlgFormatIndex,} DlgScaleCheck, Which,
    ErrorCode, i ,ii{ Count, ErrorCodex, ErrorCodey }: integer;
  dXMIN,dYMIN,dXMAX,dYMAX,dXTemp,dYTemp{,XTemp,YTemp}:Double;

begin
  bDLGSelected := False;
  dYMIN := 0;dXMIN := 0;   dYMAX := 0;dXMAX := 0; {Compiler shutup}
{Get File name, etc.. Check Radio Groups  Check File data CR/LF
Read DLG... Display Header}
{  OpenDialog1.Filter := 'Text files (*.TXT)|*.TXT|Pascal files (*.PAS)' +
    '|*.PAS|Quattro Pro files (*.WB1)|*.WB1';
OpenDialog1.Filter := 'All files|*.*;*.PAS;*.WB1';}
  DLGOpenDialog.InitialDir := DLGPath;
  DLGOpenDialog.Filter :=
    'DLG data (*.dlg,*.*f, *.opt)|*.dlg;*.*f;*.opt';
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then
  begin
    DLGMemo.Lines.Clear;
    DLGPath := ExtractFilePath(DLGOpenDialog.filename);
    temp := ExtractFileName(DLGOpenDialog.filename);
    THints.Caption := 'DLG Header Display';
    DLGFileEdit.Text := temp;
    DlgPathLabel.Caption:=DLGPath;
    ShapePathLabel.Caption:=ShapePath;
    temp := ExtractFileExt(DLGOpenDialog.filename);
    if ((uppercase(temp) = '.DLG')
      or (uppercase(temp) = '.OPT')
      or (uppercase(temp[length(temp)]) = 'F') ) then
      begin
   {Extreme until figure out what other file types}
      bDLGSelected := True;

    TempExt := Uppercase(ExtractFileExt(DLGOpenDialog.filename));
    if ((TempExt[4] = 'F') and
      (DLGOpenDialog.filename[length(DLGOpenDialog.filename) - 7] <>
        '-')) then
    begin
      temp := ExtractFileName(DLGOpenDialog.filename);
      temp[length(temp) - 3] := '-';
      TempName := DLGPath + temp + '.dlg';{TempExt;}
      if (not RenameFile(DLGOpenDialog.filename, TempName)) then
        DoRezError(3) else
      begin
      {Rename other file  dlg to attribute}
        TempNameS := DLGOpenDialog.filename;
        TempNameS[length(TempNameS)] := 'a';
        if FileExists(TempNameS) then
        begin
          {TempExt := lowercase(ExtractFileExt(TempNameS));
          temp := ExtractFileName(TempNameS);
          temp[length(temp) - 3] := '-';
          TempNameS2 := DLGPath + temp + TempExt;}
          {TempNameS2[length(TempNameS2)] := 'a';
          TempNameS2[Length(TempNameS2) - 4] := 'a';}
          temp :=  ChangeFileExt(TempName,'.sat');
          if (not RenameFile(TempNameS, temp)) then
            DoRezError(3);
        end else DoRezError(4); {Fileexists}
      end; {Rename}
    end else TempName := DLGOpenDialog.filename;

{Check Header }
      AssignFile(F1, TempName);
      Reset(F1);
{Check Header }
      DLGhasLinefeeds := False;
      DLGhasCrReturns := False;
      for i := 1 to 170 do
      begin
        Read(F1, Ch);
        if (ord(Ch) = 10) then DLGhasCrReturns := True;
        if (ord(Ch) = 13) then DLGhasLinefeeds := True;
      end;
      if ((DLGhasCrReturns) and (not DLGhasLinefeeds)) then
      begin
        DLGhasLinefeeds := False;
        CloseFile(F1);
        AssignFile(DLGBlockIn, TempName);
        Reset(DLGBlockIn, 1); {Cause it has a lF but no CR}
      end else
      begin
        if (DLGhasLinefeeds) then
          begin DLGhasCrReturns := False; Reset(F1) end else
        begin
          CloseFile(F1);
          AssignFile(DLGBlockIn,TempName);
          Reset(DLGBlockIn, 80)
        end;
      end;
      DLGFileEdit.Text := ExtractFileName(TempName);
      temp := ExtractFileName(TempName);
      temp := ChangeFileExt(temp, '.DXF');
      DXFNameEdit.Text := temp;
      temp := copy(temp, 1, (length(temp) - 4));
      Which := DLGIRG.ItemIndex;
      case Which of
        0: temp := temp + '_p';
        1: temp := temp + '_l';
        2: temp := temp + '_a';
      end; {of case}
      temp := (temp + '.shp');

      If length(temp)> 12 then
      begin
        TempNameS2 := '12345678.shp'; {s38 08917-3 af_a.shp}
        ii:=1;
{        for I:= length(temp)-12 to length(temp) do}
        for I:= (pos('.',temp)-11) to (pos('.',temp)-4) do
        begin
         TempNameS2[ii] := temp[I];
         inc(ii);
        end;
         TempNameS2[8]:=temp[(pos('.',temp)-1)];
      end else  TempNameS2 := temp;
      ShapeNameEdit.Text := TempNameS2;
Application.ProcessMessages;

      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
      DLGMemo.Lines.Add(InString);
{Get Scale}
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
      DLGMemo.Lines.Add(InString);
      ScaleString := Copy(InString, 53, 7); {53..60}
      val(ScaleString, DlgScaleCheck, Errorcode);
      str(DlgScaleCheck, ScaleString);
      DIScale.Text := ScaleString;
      ScaleString := Copy(InString, 42, 9); {42..51}
      val(ScaleString, DlgScaleCheck, Errorcode);
      str(DlgScaleCheck, ScaleString);
      DLGDateEdit.Text := ScaleString;
      ScaleString := Copy(InString, 1, 40); {1..40}
      ScaleString := trim(ScaleString);
      DLGNameEdit.Text := ScaleString;

{Read past the header not used at this time}
      for i := 1 to 8 do begin
        if (DLGhasCrReturns) then begin
          InString := ''; Ch := 'a';
          while (ord(Ch) <> 10) do begin
            BlockRead(DLGBlockIn, Ch, 1);
            InString := InString + Ch; end; end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else begin
            BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
        DLGMemo.Lines.Add(InString);
      end;
{Get the Corners... as this is in ?? coordinates
 the actual min and max are indeterminate of an absolute value
 this makes sure the min and max values of THIS DLG are recorded}
(*XMIN:= 0;{99999999;}
YMIN:= 0;{99999999;}
XMAX:=0;{ -99999999;}
YMAX:=0;{ -99999999;}
   For i:=1 to 4 do begin   *)
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
   {Read the First}
      DLGMemo.Lines.Add(InString);
      temp2 := Copy(InString, 37, 11);
      temp := trim(temp2);
      Val(temp, dXTemp, ErrorCode);
      if ErrorCode = 0 then begin
{   If XTemp > XMAX then } dXMAX := dXTemp;
{   If XTemp < XMIN then } dXMIN := dXTemp;
      end else
                  MessageDlgPos('X Error ' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
      temp2 := Copy(InString, 49, 11);
      temp := trim(temp2);
      Val(temp, dYTemp, ErrorCode);
      if ErrorCode = 0 then begin
{   If YTemp > YMAX then} dYMAX := dYTemp;
{   If YTemp < YMIN then} dYMIN := dYTemp;
      end else DoRezError(10);
(*   End;*)
      str(dXTemp: 24: 12, temp); str(dYTemp: 24: 12, temp2);
      DLGMemo.Lines.Add('X: ' + temp + ' Y: ' + temp2);
      for i := 1 to 3 do begin {Then read the next three}
        if (DLGhasCrReturns) then begin
          InString := ''; Ch := 'a';
          while (ord(Ch) <> 10) do begin
            BlockRead(DLGBlockIn, Ch, 1);
            InString := InString + Ch; end; end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else begin
            BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
        DLGMemo.Lines.Add(InString);
        temp2 := Copy(InString, 37, 11);
        temp := trim(temp2);
        Val(temp, dXTemp, ErrorCode);
        if ErrorCode = 0 then begin
          if dXTemp > dXMAX then dXMAX := dXTemp;
          if dXTemp < dXMIN then dXMIN := dXTemp;
        end else DoRezError(9);
        temp2 := Copy(InString, 49, 11);
        temp := trim(temp2);
        Val(temp, dYTemp, ErrorCode);
        if ErrorCode = 0 then begin
          if dYTemp > dYMAX then dYMAX := dYTemp;
          if dYTemp < dYMIN then dYMIN := dYTemp;
        end else DoRezError(10);
        str(dXTemp: 24: 12, temp); str(dYTemp: 24: 12, temp2);
        DLGMemo.Lines.Add('X: ' + temp + ' Y: ' + temp2);
      end;
      str(dXMIN: 24: 12, temp);
      DLGMemo.Lines.Add('XMIN: ' + temp);
      str(dYMIN: 24: 12, temp);
      DLGMemo.Lines.Add('YMIN: ' + temp);
      str(dXMAX: 24: 12, temp);
      DLGMemo.Lines.Add('XMAX: ' + temp);
      str(dYMAX: 24: 12, temp);
      DLGMemo.Lines.Add('YMAX: ' + temp);
{Get the DLG type, and number of points, areas, lines}
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
      DLGMemo.Lines.Add(InString);
      temp := Copy(InString, 31, 6);
      temp1 := trim(temp);
      Val(temp1, Points, ErrorCode);
      if ErrorCode <> 0 then Codefx(temp1,ErrorCode);
      temp := Copy(InString, 47, 6);
      temp2 := trim(temp);
      Val(temp2, Areas, ErrorCode);
      if ErrorCode <> 0 then Codefx(temp2,ErrorCode);
      temp := Copy(InString, 63, 6);
      temp3 := trim(temp);
      Val(temp3, Lines, ErrorCode);
      if ErrorCode <> 0 then Codefx(temp3,ErrorCode);
      THints.Caption := 'Points ' + temp1 + ' Areas ' + temp2 +
        ' Lines ' + temp3;
      DIPointIn.Text := temp1;
      DIAreaIn.Text := temp2;
      DILineIn.Text := temp3;
{end else  Message Dlg('File MUST have linefeeds',
                       mtInformation,[mbOk], 0);}
      if (DLGhasLinefeeds) then CloseFile(F1) else
        CloseFile(DLGBlockIn);
    end else DoRezError(11); {is DLG}
  end; {file open} DLGGauge.Position := 0;
end; {this}
(*******************************************************************)


(******************************************************************)

procedure TTransformer.DLGDXFExportBtnClick(Sender: TObject);
var
  DLGBlockIn: file;
  F1, DxfOutFile: TextFile;
  InBuf: array[1..80] of char;
  DLGDone: Boolean; Ch: Char;
{ScaleString,}{In2String,}{temp3, } temp2, temp, InString: string;
  Which: Integer;
{PointCount,} NumberLines, Number, Oddpoints, CountDracula,
    Count3, CountOdd, {AreaCount,} LineCount, CountLines,
{Points, Lines, Areas,} Count,
    ErrorCode, i, {ii,} ErrorCodex, ErrorCodey, DXFLineWidth:
      integer;
{RecordLength,DlgFormat,DlgScale,DlgScaleCheck,
DlgFormatIndex,DlgScaleIndex:integer;}
{XShift, YShift,Ratio, XMIN,YMIN,XMAX,YMAX,} XTemp, YTemp
{,xdiff,ydiff}: Double;
begin
{Read DLG...set up DXF, write to a DXF}
{If (DLGhasLinefeeds = True) then begin}
  if (bDLGSelected = True) then begin
 {File has been Chosen and set}
    Which := DXFLineWidthRG.ItemIndex;
    case Which of
      0: DXFLineWidth := 0;
      1: DXFLineWidth := 1;
      2: DXFLineWidth := 2;
      3: DXFLineWidth := 3;
    else DXFLineWidth := 1;
    end; {of case}
    AssignFile(F1, TempName);
    Reset(F1);
{Check Header }
    DLGhasLinefeeds := False;
    DLGhasCrReturns := False;
    for i := 1 to 170 do begin Read(F1, Ch);
      if (ord(Ch) = 10) then DLGhasCrReturns := True;
      if (ord(Ch) = 13) then DLGhasLinefeeds := True; end;
    if ((DLGhasCrReturns) and (not DLGhasLinefeeds)) then begin
      DLGhasLinefeeds := False;
      CloseFile(F1);
      AssignFile(DLGBlockIn, TempName);
      Reset(DLGBlockIn, 1); {Cause it has a lF but no CR}
    end else begin
      if (DLGhasLinefeeds) then
        begin DLGhasCrReturns := False; Reset(F1) end else
      begin CloseFile(F1); AssignFile(DLGBlockIn,TempName);
        Reset(DLGBlockIn, 80) end; end;


    temp := (DLGPath + DXFNameEdit.Text);
    AssignFile(DxfOutFile, temp);
    Rewrite(DxfOutFile);
    temp := trim(Uppercase(DXFLayerEdit.Text));
    DXFLayerEdit.Text := temp;
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'TABLES');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'TABLE');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'LAYER');
{    Writeln(DxfOutFile, inttostr(70));
    Writeln(DxfOutFile, inttostr(25));}
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'LAYER');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, DXFLayerEdit.Text);
{    Writeln(DxfOutFile, inttostr(70));
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, inttostr(6));
    Writeln(DxfOutFile, 'CONTINUOUS');
    Writeln(DxfOutFile, inttostr(62));
    Writeln(DxfOutFile, inttostr(1));   }
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDTAB');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'SECTION');
    Writeln(DxfOutFile, inttostr(2));
    Writeln(DxfOutFile, 'ENTITIES');
{Skip Header}
    for i := 1 to 15 do begin
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
    end;
{Skip Points}
{For i := 1 to Points do begin readln(F1,Instring);
readln(F1,Instring);end;
   str(Points,temp); DIPointOut.Text:=temp;}
{Skip Areas}
{
If ((Areas > 0 ) or (Points > 0 )) then begin
  AreaCount:=1;Points:=0;
  Repeat begin
        Readln(F1, InString);In2String:=InString;
        If (In2String[1] = 'N') then inc(Points);
        If (In2String[1] = 'A') then inc(AreaCount);
        end;
  until Areas = AreaCount;
end;
str(Points,temp); DIPointOut.Text:=temp;
str(AreaCount,temp); DIAreaOut.Text:=temp;
}
    str(0, temp); DIPointOut.Text := temp;
    str(0, temp); DIAreaOut.Text := temp;

{Read and write Lines}
{Read in Lines}
    DLGGauge.Position := 0;
    LineCount := 0; Count := 0;
{For Count := 1 to Lines}
{While (not EOF(F1)) do begin}
    DLGDone := False;
    while ((not DLGDone)) do begin
      inc(Count); {crashed here... Lines is 0}
      DLGGauge.Position := (Count div (Lines div 100));
      if (DLGhasCrReturns) then begin
        InString := ''; Ch := 'a';
        while (ord(Ch) <> 10) do begin
          BlockRead(DLGBlockIn, Ch, 1);
          InString := InString + Ch; end; end else
        if (DLGhasLinefeeds) then Readln(F1, InString) else begin
          BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf; end;
      if InString[1] = 'L' then begin {Get number of points per line}
        temp := Copy(InString, 3, 6);
        temp2 := trim(temp);
        Val(temp2, CountDracula, ErrorCode);
        temp := Copy(InString, 42, 8);
        temp2 := trim(temp);
        Val(temp2, Number, ErrorCode);
        if (ErrorCode = 0) then begin
          inc(LineCount);
          if (LineCount <> CountDracula) then begin
            str(Linecount, temp);
          MessageDlgPos('Lines are maligned at ' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
            LineCount := CountDracula;
          end;
          NumberLines := Number div 3;
          Oddpoints := Number mod 3;
 {Write out Line header}
          Writeln(DxfOutFile, inttostr(0));
          Writeln(DxfOutFile, 'POLYLINE');
          Writeln(DxfOutFile, inttostr(8));
          Writeln(DxfOutFile, DXFLayerEdit.Text);
          Writeln(DxfOutFile, inttostr(70));
          Writeln(DxfOutFile, inttostr(8));
          Writeln(DxfOutFile, inttostr(40));
          Writeln(DxfOutFile, inttostr(DXFLineWidth));
          Writeln(DxfOutFile, inttostr(41));
          Writeln(DxfOutFile, inttostr(DXFLineWidth));
          Writeln(DxfOutFile, inttostr(66));
          Writeln(DxfOutFile, inttostr(1));
        Writeln(DxfOutFile, inttostr(10));{who knows why}
          Writeln(DxfOutFile, '0.000000');
          Writeln(DxfOutFile, inttostr(20));{who knows why}
          Writeln(DxfOutFile, '0.000000');
          Writeln(DxfOutFile, inttostr(30));{who knows why}
          Writeln(DxfOutFile, '0.000000');
  {Process the points into a line}
          if NumberLines > 0 then begin
            for CountLines := 1 to NumberLines do begin
              if (DLGhasCrReturns) then begin
                InString := ''; Ch := 'a';
                while (ord(Ch) <> 10) do begin
                  BlockRead(DLGBlockIn, Ch, 1);
                  InString := InString + Ch; end; end else
                if (DLGhasLinefeeds) then Readln(F1, InString) else
                  begin
                  BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                    end;
              for Count3 := 1 to 3 do begin
                temp := Copy(InString, (1 + (24 * (Count3 - 1))),
                  12); temp := trim(temp);
                Val(temp, XTemp, ErrorCodex);
                temp2 := Copy(InString, (13 + (24 * (Count3 - 1))),
                  12); temp2 := trim(temp2);
                Val(temp2, YTemp, ErrorCodey);
                if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                  Writeln(DxfOutFile, inttostr(0));
                  Writeln(DxfOutFile, 'VERTEX');
                  Writeln(DxfOutFile, inttostr(8));
                  Writeln(DxfOutFile, DXFLayerEdit.Text);
                  Writeln(DxfOutFile, inttostr(10));
                  Writeln(DxfOutFile, XTemp);
                  Writeln(DxfOutFile, inttostr(20));
                  Writeln(DxfOutFile, YTemp);
                  Writeln(DxfOutFile, inttostr(30));
                  Writeln(DxfOutFile, '0.000000');
{   XTemp:=XTemp+XShift; YTemp:=YTemp+YShift;
   i:=trunc((XTemp/Ratio));ii:=trunc((YTemp/Ratio));
   QuickViewImage.Canvas.LineTo(i,312-ii);}
                end else
                  MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
              end; end; end;

          if (Oddpoints > 0) then begin
            if (DLGhasCrReturns) then begin
              InString := ''; Ch := 'a';
              while (ord(Ch) <> 10) do begin
                BlockRead(DLGBlockIn, Ch, 1);
                InString := InString + Ch; end; end else
              if (DLGhasLinefeeds) then Readln(F1, InString) else
                begin
                BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
                  end;
            for CountOdd := 1 to Oddpoints do begin
              temp := Copy(InString, (1 + (24 * (CountOdd - 1))),
                12); temp := trim(temp);
              Val(temp, XTemp, ErrorCodex);
              temp2 := Copy(InString, (13 + (24 * (CountOdd - 1))),
                12); temp2 := trim(temp2);
              Val(temp2, YTemp, ErrorCodey);
              if ((ErrorCodex = 0) and (ErrorCodey = 0)) then begin
                Writeln(DxfOutFile, inttostr(0));
                Writeln(DxfOutFile, 'VERTEX');
                Writeln(DxfOutFile, 8);
                Writeln(DxfOutFile, DXFLayerEdit.Text);
                Writeln(DxfOutFile, inttostr(10));
                Writeln(DxfOutFile, XTemp);
                Writeln(DxfOutFile, inttostr(20));
                Writeln(DxfOutFile, YTemp);
                  Writeln(DxfOutFile, inttostr(30));
                  Writeln(DxfOutFile, '0.000000');
{   XTemp:=XTemp+XShift; YTemp:=YTemp+YShift;
   i:=trunc((XTemp/Ratio));ii:=trunc((YTemp/Ratio));
    QuickViewImage.Canvas.LineTo(i,312-ii);}
              end; end; end;

        end else
                  MessageDlgPos('Points this Line WRONG' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
{Write out Line }
        Writeln(DxfOutFile, inttostr(0));
        Writeln(DxfOutFile, 'SEQEND');
        Writeln(DxfOutFile, inttostr(8));
        Writeln(DxfOutFile, DXFLayerEdit.Text);
      end; {Of a Line}
      if (DLGhasLinefeeds) then
        DLGDone := EOF(F1) else DLGDone := EOF(DLGBlockIn);
    end;
    if (DLGhasLinefeeds) then CloseFile(F1) else
      CloseFile(DLGBlockIn);
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'ENDSEC');
    Writeln(DxfOutFile, inttostr(0));
    Writeln(DxfOutFile, 'EOF');

    CloseFile(DxfOutFile);

    DLGGauge.Position := 0;
    str(LineCount, temp2);
   {Message Dlg('Number of Lines Read '+temp2,
   mtInformation,[mbOk], 0);}
    THints.Caption := 'Number of Lines Read ' + temp2;
    DILineOut.Text := temp2;
  end else DoRezError(12);
end;
(*****************************************************************)
(******************************************************************)

procedure TTransformer.DLGIRGClick(Sender: TObject);
var Which: Integer;
begin
  Which := DLGIRG.ItemIndex;
  case Which of
    0: begin {ShapeNameEdit.Text := '_p' + ShapeNameEdit.Text;}
        ShapeLayerEdit.Text := 'Points'; end;
    1: begin {ShapeNameEdit.Text := '_l' + ShapeNameEdit.Text;}
        ShapeLayerEdit.Text := 'Lines'; end;
    2: begin {ShapeNameEdit.Text := '_a' + ShapeNameEdit.Text;}
        ShapeLayerEdit.Text := 'Areas'; end;
        else ShapeLayerEdit.Text := 'NO thing done';
  end; {of case}
end;
(*******************************************************************)

procedure TTransformer.DLGSingleCodeCBClick(Sender: TObject);
begin
  if (DLGSingleCodeCB.checked) then
  begin
    DLGMinorCodesCB.Checked := false;
    DLGAttSymCB.Checked := false;
  end;
end;

procedure TTransformer.DLGMinorCodesCBClick(Sender: TObject);
begin
  if (DLGMinorCodesCB.checked) then
  begin
    DLGSingleCodeCB.Checked := false;
    DLGAttSymCB.Checked := false;
  end;
end;
procedure TTransformer.DLGAttSymCBClick(Sender: TObject);
begin
  if (DLGAttSymCB.checked) then
  begin
    DLGSingleCodeCB.Checked := false;
    DLGMinorCodesCB.Checked := false;
  end;
end;
(******************************************************************)

procedure TTransformer.DLGShapeExportDIRBtnClick(Sender: TObject);
var
 temp:String;
begin
  DLGOpenDialog.Filter := 'Shape file here TOO(*.*)|*.*';
  DLGOpenDialog.InitialDir := ShapePath;
  temp:=DLGOpenDialog.filename;
  If (ShapeNameEdit.Text='ShapeNameEdit')then
    DLGOpenDialog.Filename:=ShapeNameEdit.Text+'.shp'
    else DLGOpenDialog.Filename:=ShapeNameEdit.Text;
  if DLGOpenDialog.execute then
  begin
    ShapePath := ExtractFilePath(DLGOpenDialog.Filename);
    ShapePathLabel.Caption:=ShapePath;
  end else
  DLGOpenDialog.filename:=temp;
end;


{Read, Compute, Write}

procedure TTransformer.DLGShapeExportBtnClick(Sender: TObject);
type
  MyLineRecord = record
    LineNumber,
    NumberOfPoints,
    AttributeN: Integer;
    AAttributes: string;
    LinesPoints: array of Double;
  end;
  MyAreaRecord = record
    AreaNumber,
    AreaLinesN,
    NumberOfPoints,
    AttributeN,
    IslandsN: Integer;
    AAttributes: string;
    {Ring#1,0,Ring#2,?  two records per ring}
    IslandsArray, {A zero record indicates start of next string in DLG}
    ALines: array of integer; {line numbers per area}
    ALinesPoints: array of Double; {all line points per area}
  end;
var
  LineRecord: array of MyLineRecord;
  AreaRecord: array of MyAreaRecord;
  SymArray: array of string;
  InBuf: array[1..80] of char;
  dbTable: TTable;
  AttSymFile, F1: TextFile;
  IndexFileOut, ShapeFileOut, DLGBlockIn: file;
{if (DLGSkipFirstBox.Checked) then Skipper :=1}
bDLGSingleCodeCB, bDLGMinorCodesCB,bNothingChecked,
  bDLGXaa, bDLGSym, bDLGAtt,bDLGAttSymCB,
  bSkipSsurgoBlankHalfCB,  bSsurgoSpecialFeatureCB,
  bDLGNumberItemsCB, bAddMapAttributesCB,
  DLGDone,  bFirstTooLong, bLastTooLong, bBothTooLong,
  bIslandHopping, TwistedSister, bCheckLines: Boolean;
  Checker: Word;
  Ch: Char;
  {TempName is DLG file}  DLGShapeFileName, DLGIndexFileName,
  atemp, temp2NRI,  AttSymstring,
  DuplicatorS, DuplicatorS2,
  tempStr, temp2, temp, InString, ShapeString: string;
  StartingPoint, FinishingPoint, ISoManyPoints, IChar, SymChar,
  DoThisMany, DoThisone, IShape, IShp, DoThisoneI, IslandLine,
  ShapeAttributeN2, ShapeAttributeN3, TotalPointsAdded,
  TotalLinePointSets, TotalShapePointSets,
  ShapeFileSize, IndexFileSize,   RecordSize,
  IndexOffset,IndexOffsetTotal, PointCount,  PointCountTotal,
  ShapeLineNumber, ShapeLinePoints, ShapeLinePointsN,
  TotalLinePointsAdded,
  ShapeAttributeLN, MaxShapeAttributeLN, MaxShapeIslandsCount,
  ShapeAttributePN, MaxShapeAttributePN, MasterMaxShapeAttributeN,
  ShapeN, ShapeLinesN, ShapeAttributeN, ShapeIslandsN,
  TotalShapeIslandsN, MaxShapeAttributeN, MaxShapeIslandsN,
  ShapeInteger, Shapetype, Which, Skipper, SymArrayCounter,

  IIAreaCount, IAreaCount,  SoManyPoints, IslandHopperI,
  NumberLines, Number, Oddpoints, CountDracula, IslandCounter,
  IslandCounter2,   CountLines,  Incrementer,
  LinePointCount, Count3, CountOdd, AreaCount, LineCount,
  II, Count, ErrorCode, ErrorCodex, ErrorCodey, RecordLength
  : integer;
    dXMIN,dYMIN,dXMAX,dYMAX,dXTemp,dYTemp,
  XTemp, YTemp, XMIN, YMIN, XMAX, YMAX: Double;
procedure SwapShapeInteger(Incoming: Integer);
  var ByteArray: array[0..3] of Byte;
begin
    Move(Incoming, ByteArray, 4);
    ShapeByte := ByteArray[3];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[2];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[1];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[0];
    BlockWrite(ShapeFileOut, ShapeByte, 1);
end;
procedure SwapIndexInteger(Incoming: Integer);
  var ByteArray: array[0..3] of Byte;
begin
    Move(Incoming, ByteArray, 4);
    ShapeByte := ByteArray[3];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[2];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[1];
    BlockWrite(IndexFileOut, ShapeByte, 1);
    ShapeByte := ByteArray[0];
    BlockWrite(IndexFileOut, ShapeByte, 1);
end;

begin{ DLGShapeExportBtnClick   Procedure}
  {File has been Chosen and basic data read} {DLGhasLinefeeds}
  if ( bDLGSelected = True) then
  begin
    if (Length(ExtractFileName(ShapeNameEdit.Text)) < 13) then
    begin
    Try
      {Create New Shape File name}
      DLGShapeFileName := ShapePath + ShapeNameEdit.Text;
      inc(MyDbCount); { Initialize MyDbCount early on }
      bCheckLines := True;
      bDLGSingleCodeCB := DLGSingleCodeCB.Checked;
      bDLGMinorCodesCB := DLGMinorCodesCB.Checked;
      bDLGAttSymCB := DLGAttSymCB.Checked;
      bDLGSym := False;
      bDLGAtt := False;
      bDLGXaa := False;
      If ((bDLGAttSymCB)and(SkipSsurgoBlankHalfCB.Checked)) then
         bSkipSsurgoBlankHalfCB:=True else bSkipSsurgoBlankHalfCB:=False;
      If ((bDLGAttSymCB)and(SsurgoSpecialFeatureCB.Checked)) then
        bSsurgoSpecialFeatureCB:=True else bSsurgoSpecialFeatureCB:=False;
      bDLGNumberItemsCB := DLGNumberItemsCB.Checked;
      bAddMapAttributesCB := AddMapAttributesCB.Checked;
      If (bDLGMinorCodesCB or bDLGSingleCodeCB or bDLGAttSymCB) then
      bNothingChecked:=False else bNothingChecked:=True;
        {TwistedSister:=False;}
      TotalPointsAdded := 0;
      AssignFile(F1, TempName);
      Reset(F1);
      {Check Header to determine how to read file}
      DLGhasLinefeeds := False;
      DLGhasCrReturns := False;
      for Incrementer := 1 to 170 do
      begin Read(F1, Ch);
        if (ord(Ch) = 10) then DLGhasCrReturns := True;
        if (ord(Ch) = 13) then DLGhasLinefeeds := True;
      end;
      if ((DLGhasCrReturns) and (not DLGhasLinefeeds)) then
      begin
        DLGhasLinefeeds := False;
        CloseFile(F1);
        AssignFile(DLGBlockIn, TempName);
        Reset(DLGBlockIn, 1); {Cause it has a lF but no CR}
      end else
      begin
        if (DLGhasLinefeeds) then
        begin
          DLGhasCrReturns := False;
          Reset(F1)
        end else
        begin
          CloseFile(F1);
          AssignFile(DLGBlockIn,TempName);
          Reset(DLGBlockIn, 80)
        end;
      end;

      MaxShapeIslandsCount := 0;
      MaxShapeAttributeN := 0;
      MaxShapeAttributeLN := 0; {ShapeAttributeLN:=0;}
      MaxShapeAttributePN := 0; { ShapeAttributePN:=0;}
      TotalLinePointsAdded := 0;
      ShapeAttributeN3 := 0;
          {IslandCounter:=0;}
      {Determine which type of Shape file to create
             .. read Point data now}
      Which := DLGIRG.ItemIndex;
      case Which of
        0:begin
            Shapetype := 1; {point}
            THints.Caption := 'Reading DLG Points';
            ShapeLayerEdit.Text := 'Points';
                      {14= 4+ 2 + 8}
            ShapeFileSize := ((Points * 14) + 50);
            IndexFileSize := ((Points * 4) + 50);
              {(Each point set is a header, shape type,and the 2 points)
                + Main header, in 16 bit words - not bytes}
              {Must read to set MaxAttributesPN}
            Count := 0;
            repeat
              begin
                  if (DLGhasCrReturns) then
                  begin
                    InString := '';
                    Ch := 'a';
                    while (ord(Ch) <> 10) do
                    begin
                      BlockRead(DLGBlockIn, Ch, 1);
                      InString := InString + Ch;
                    end;
                  end else
                    if (DLGhasLinefeeds) then
                      Readln(F1, InString) else
                  begin
                      BlockRead(DLGBlockIn, InBuf, 1);
                      InString := InBuf;
                  end;
                  if InString[1] = 'N' then
                  begin {Get number of points per line}
                    inc(Count);
                    DLGGauge.Position :=
                    (Count div (Points div 100));
                    Application.ProcessMessages;
                    temp := Copy(InString, 49, 6);
                    Val(temp, ShapeAttributePN, ErrorCodex);
                    if (ErrorCodex > 0) then
                      Codefx(temp, ErrorCodex) else
                      if (ShapeAttributePN > MaxShapeAttributePN)
                        then
                        MaxShapeAttributePN := (ShapeAttributePN);
                  end;
              end;
                if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
                  DLGDone := EOF(DLGBlockIn);
            until ((Count = Points) or (DLGDone));
            IAttPEdit.Text:=InttoStr(MaxShapeAttributePN);
          end;
        1:begin
            If bSsurgoSpecialFeatureCB then
            begin
              DoRezError(18);
              if (DLGhasLinefeeds) then
              CloseFile(F1) else CloseFile(DLGBlockIn);
              Exit; {This procedure}
            end;
              Shapetype := 3; {arc line}
              ShapeLayerEdit.Text := 'Lines';
              SetLength(LineRecord, Lines + 1);
             {Waste record zero, but easier to work and read}
          end;
        2:begin
              Shapetype := 5;{polygon area}
              ShapeLayerEdit.Text := 'Areas';
             {Points, Lines, Areas: already known}
             Skipper := 1;
              if (DLGSkipFirstCB.Checked) then Skipper := 2;
              if bSkipSsurgoBlankHalfCB  then Skipper := 3;
              SetLength(LineRecord, Lines + 1);
              SetLength(AreaRecord, Areas + 1);
{array[0] is nada not used to avoid confusion?
Areas   1..Areas  Read them all, Process:  For Skipper to Areas Do
Statsgo.sym is 0..? select: read all into array[0..?]
                    process: iaw dlg minor using array
ssurgo is 1..areas  select: read(Skipper-1)
                    process: read for each area as processed

Lines are 1..Lines
   Read them all, Process(all anyway): For 1 to Lines Do
                  so select using line #
Special Features are Lines what to do what to do?
}
          end;
        3:begin
              Shapetype := 8; {MultiPoints}
              ShapeLayerEdit.Text := 'MultiPoints';
              DoRezError(13);
          end;
         else Shapetype := 0;
      end; {Case}
      If ((Shapetype=8)or(Shapetype=0))then
      begin
          if (DLGhasLinefeeds) then
              CloseFile(F1) else CloseFile(DLGBlockIn);
      Exit; {This procedure}
      end;
      {---------------------------------------------------------}
      {Read data for Areas}
      {---------------------------------------------------------}
if (Shapetype = 5) then
begin {Read in All the areas}
  THints.Caption := 'Reading Areas .. and rest of DLG file ';
  AreaCount := (1);
  TotalShapeIslandsN := 0;
  MaxShapeAttributeN := 0;
  MaxShapeIslandsN := 0;
  if (DLGhasLinefeeds) then Reset(F1) else
  if (DLGhasCrReturns) then Reset(DLGBlockIn, 1)
  else Reset(DLGBlockIn, 80);
  DLGDone := False;
  while ((not DLGDone)) do
  begin{  Repeat begin}
    if (DLGhasCrReturns) then
    begin
      InString := ''; Ch := 'a';
      while (ord(Ch) <> 10) do
      begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch;
      end;
    end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else
    begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
    end;

    if InString[1] = 'A' then
    begin {Get number of points per line}
      DLGGauge.Position :=
             (AreaCount div ((Areas div 100) + 1));
      Application.ProcessMessages;
      IslandCounter := 0;
      temp2 := Copy(InString, 2, 5);
      temp := trim(temp2);
      Val(temp, ShapeN, ErrorCodex); {Area ID#}
      if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
      temp2 := Copy(InString, 37, 6);
      temp := trim(temp2);
      Val(temp, ShapeLinesN, ErrorCodey); {# of lines}
      if (ErrorCodey > 0) then Codefx(temp, ErrorCodey);
      if ((ErrorCodex = 0) and (ErrorCodey = 0)) then
      begin
        AreaRecord[AreaCount].AreaNumber := (ShapeN);
                {ACTUAL SHAPE ID...}
        if ( (bCheckLines)
             and (AreaCount <> (ShapeN ))) then
        begin
          str(AreaCount, temp);
          Checker :=
              MessageDlgPos('Wrong numbered Area at ' +temp,
                    mtWarning, mbAbortRetryIgnore{[mbOK]},
                    0, MessageX, MessageY);
          if (Checker = mrIgnore) then bCheckLines := False else
          if (Checker = mrRetry) then AreaCount := ShapeN
             {tries to correct the situation}
          else exit;
          {retry to continue or abort and exit}
        end;
        AreaRecord[AreaCount].AreaLinesN := ShapeLinesN;
        temp2 := Copy(InString, 49, 6);
        temp := trim(temp2);
        Val(temp, ShapeAttributeN, ErrorCodex);
           {# of attributes}
        if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
        temp2 := Copy(InString, 61, 6);
        temp := trim(temp2);
        Val(temp, ShapeIslandsN, ErrorCodey); {# of islands}
        if (ErrorCodey > 0) then Codefx(temp, ErrorCodey);
        AreaRecord[AreaCount].AttributeN := ShapeAttributeN;
        AreaRecord[AreaCount].IslandsN := ShapeIslandsN;
        if (AreaCount > 0) then {Skipper skipper}
            TotalShapeIslandsN :=
            (TotalShapeIslandsN + ShapeIslandsN);
             {Each island has a Zero record before it,
                need to store # of islands AND where it is
                do it later, set length for it now}
        if (ShapeIslandsN > 0) then
             setlength(AreaRecord[AreaCount].IslandsArray,
                       ((ShapeIslandsN * 2) + 2));
        if (ShapeAttributeN > MaxShapeAttributeN) then
                MaxShapeAttributeN := (ShapeAttributeN);
        if (ShapeIslandsN > MaxShapeIslandsN) then
        begin
          MaxShapeIslandsN := (ShapeIslandsN);
          str(AreaCount + 1, temp);
          str(MaxShapeIslandsN, temp2);
          DLGMemo.Lines.Add(temp2 + ' Islands at Area ' + temp);
        end;
        ShapeString := '';              {ShapeLinesN}
        IAreaCount := ((AreaRecord[AreaCount].AreaLinesN)div 12);
        if (((AreaRecord[AreaCount].AreaLinesN)mod 12) > 0)
            then inc(IAreaCount);
        for IIAreaCount := 1 to IAreaCount do
        begin
               {12 line numbers per line}
          if (DLGhasCrReturns) then
          begin
            InString := '';
            Ch := 'a';
            while (ord(Ch) <> 10) do
            begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch;
            end;
          end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else
          begin
            BlockRead(DLGBlockIn, InBuf, 1); InString :=InBuf;
          end;
          temp := TrimRight(InString);
          ShapeString := (ShapeString + temp);
        end; {IIAreaCount}
        {Convert into line numbers}
        IAreaCount := AreaRecord[AreaCount].AreaLinesN;
        setlength(AreaRecord[AreaCount].ALines, IAreaCount);
        for IIAreaCount := 0 to ({ShapeLinesN} IAreaCount - 1) do
        begin
          temp2 :=
              Copy(ShapeString, (1 + ((IIAreaCount) *6)), 6);
          temp := trim(temp2);
          Val(temp, ShapeLinePointsN, ErrorCodex);
          if (ErrorCodex > 0) then Codefx(temp, ErrorCodey);
          AreaRecord[AreaCount].ALines[IIAreaCount]
                    := ShapeLinePointsN;
        end; {IIAreaCount=0}
        If (ShapeAttributeN > 0) then
        begin
          if (DLGhasCrReturns) then
          begin
            InString := ''; Ch := 'a';
            while (ord(Ch) <> 10) do
            begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch;
            end;
          end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else
          begin
            BlockRead(DLGBlockIn, InBuf, 1);
            InString := InBuf;
          end;
          {Read the raw string now}
          temp := TrimRight(InString);
          SetLength(AreaRecord[AreaCount].AAttributes, length(temp) + 6);
          AreaRecord[AreaCount].AAttributes := temp;
        end;
        if (ShapeAttributeN > 6) then
        begin
          if (DLGhasCrReturns) then
          begin
            InString := ''; Ch := 'a';
            while (ord(Ch) <> 10) do
            begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch;
            end;
          end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else
          begin
            BlockRead(DLGBlockIn, InBuf, 1); InString :=InBuf;
          end;
          {For REALLY large attributes}
          SetLength(AreaRecord[AreaCount].AAttributes,
                (length(AreaRecord[AreaCount].AAttributes)
                    + length(InString)));
          AreaRecord[AreaCount].AAttributes
               := (AreaRecord[AreaCount].AAttributes + InString);
        end;
        inc(AreaCount);
      end else
      begin {Display incorrect points}
        DLGMemo.Lines.Add(InString);
        MessageDlgPos('Bad Areas ' + temp + ' lines ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
        exit; {This procedure}
      end; {error code}
    end; {If string A}
    if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
         DLGDone := EOF(DLGBlockIn);
  end; {EOF}
  {   until ((AreaCount=Areas)or (EOF(F1)));}
  dec(AreaCount);
  str(AreaCount , temp);
  THints.Caption := 'Areas correctly read ' + temp;
  DIAreaOut.Text := temp;
  IAttAEdit.Text:=InttoStr(MaxShapeAttributeN);
  DLGGauge.Position := 0;
  Application.ProcessMessages;
end; {Shape 5}
      {------------------------------------------------------}
      {Read in All the Lines FOR line and area Shapes}
      {------------------------------------------------------}
if ((Shapetype = 3) or (Shapetype = 5)) then
begin
  THints.Caption := 'Reading DLG Lines';
  LineCount := 0;
  TotalLinePointSets := 0;
  Count := 0;
  if (DLGhasLinefeeds) then Reset(F1) else
  if (DLGhasCrReturns) then Reset(DLGBlockIn, 1)
  else Reset(DLGBlockIn, 80);
  DLGDone := False;
  while ((not DLGDone)) do
  begin{   Repeat   begin}
    if (DLGhasCrReturns) then
    begin
      InString := '';
      Ch := 'a';
      while (ord(Ch) <> 10) do
      begin
        BlockRead(DLGBlockIn, Ch, 1);
        InString := InString + Ch;
      end;
    end else
    if (DLGhasLinefeeds) then Readln(F1, InString) else
    begin
      BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
    end;
    If InString[1] = 'L' then
    begin {Get number of points per line}
      inc(Count);
      DLGGauge.Position := (Count div ((Lines div 100) + 1));
      Application.ProcessMessages;
      LinePointCount := 0;
      temp := Copy(InString, 3, 6);
      temp2 := trim(temp);
      Val(temp2, CountDracula, ErrorCode);
      if (ErrorCode > 0) then Codefx(temp2, ErrorCode);
      temp := Copy(InString, 42, 8);
      temp2 := trim(temp);
      Val(temp2, Number, ErrorCode);
      if (ErrorCode > 0) then Codefx(temp2, ErrorCode);
      if (ErrorCode = 0) then
      begin
        inc(LineCount);
        If (bCheckLines and (LineCount <> CountDracula)) then
        begin
          str(Linecount, temp);
          Checker :=
               MessageDlgPos('Wrong numbered line at ' +temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
          if (Checker = mrIgnore) then bCheckLines := False else
          if (Checker = mrRetry) then LineCount := CountDracula
          {tries to correct the situation}
          else exit;
          {retry to continue or abort and exit}
        end;
        temp := Copy(InString, 49, 6);
        Val(temp, ShapeAttributeLN, ErrorCodex);
           {# of attributes}
        if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
        if (ShapeAttributeLN > MaxShapeAttributeLN) then
             MaxShapeAttributeLN := (ShapeAttributeLN);
        LineRecord[Count].LineNumber := CountDracula;
        LineRecord[Count].NumberOfPoints := Number;
          {TotalShapePointSets is Total for ALL Areas}
        TotalLinePointSets := (TotalLinePointSets + Number);
        LineRecord[Count].AttributeN := ShapeAttributeLN;
        {Set to length of numbers; 2 points per line: X and Y}
        Setlength(LineRecord[Count].LinesPoints, Number * 2);
        NumberLines := Number div 3; {3 point sets per line}
        Oddpoints := Number mod 3;
        {Process the points into a line,
            3 div 3 = 1; mod 3 would skip it }
        if (NumberLines > 0) then
        begin
          for CountLines := 1 to NumberLines do
          begin
            if (DLGhasCrReturns) then
            begin
              InString := ''; Ch := 'a';
              while (ord(Ch) <> 10) do
              begin
                BlockRead(DLGBlockIn, Ch, 1);
                InString := InString + Ch;
              end;
            end else
            if (DLGhasLinefeeds) then Readln(F1, InString) else
            begin
              BlockRead(DLGBlockIn, InBuf, 1);
              InString := InBuf;
            end;
            for Count3 := 0 to 2 do
            begin
              temp := Copy(InString, (1 + (24 * (Count3))),12);
              temp := trim(temp);
              Val(temp, XTemp, ErrorCodex);
              if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
              temp2 := Copy(InString, (13 + (24 * (Count3))),12);
              temp2 := trim(temp2);
              Val(temp2, YTemp, ErrorCodey);
              if (ErrorCodey > 0) then Codefx(temp2, ErrorCodey);
              if ((ErrorCodex = 0) and (ErrorCodey = 0)) then
              begin
                LineRecord[Count].LinesPoints[LinePointCount]:= XTemp;
                inc(LinePointCount);
                LineRecord[Count].LinesPoints[LinePointCount]:= YTemp;
                inc(LinePointCount);
              end else
              MessageDlgPos('Bad X ' + temp + ' Y ' + temp2,
                           mtWarning, [mbOK], 0, MessageX, MessageY);
            end; {Count 3}
          end; {Count lines}
        end; {Numberlines}
        if (Oddpoints > 0) then
        begin
          if (DLGhasCrReturns) then
          begin
            InString := '';
            Ch := 'a';
            while (ord(Ch) <> 10) do
            begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch;
            end;
          end else
          If (DLGhasLinefeeds) then Readln(F1, InString) else
          begin
            BlockRead(DLGBlockIn, InBuf, 1); InString := InBuf;
          end;
          for CountOdd := 0 to Oddpoints - 1 do
          begin
            temp :=Copy(InString, (1 + (24 * (CountOdd))),12);
            temp := trim(temp);
            Val(temp, XTemp, ErrorCodex);
            if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
            temp2 :=Copy(InString, (13 + (24 * (CountOdd))),12);
            temp2 := trim(temp2);
            Val(temp2, YTemp, ErrorCodey);
            if (ErrorCodey > 0) then Codefx(temp2, ErrorCodey);
            if ((ErrorCodex = 0) and (ErrorCodey = 0)) then
            begin
              LineRecord[Count].LinesPoints[LinePointCount]:= XTemp;
              inc(LinePointCount);
              LineRecord[Count].LinesPoints[LinePointCount]:= YTemp;
              inc(LinePointCount);
            end; {Error code}
          end; {CountOdd}
        end; {OddPoints}
        if (LinePointCount <> (Number * 2)) then
        begin
          str(LinePointCount, temp);
          str(Count, temp2);
          MessageDlgPos('Bad LinePointCount ' + temp +
                  ' Count ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
        end;
        {Read the attribute line if it exists}
        if (ShapeAttributeLN > 0) then
        begin
          if (DLGhasCrReturns) then
          begin
            InString := '';
            Ch := 'a';
            while (ord(Ch) <> 10) do
            begin
              BlockRead(DLGBlockIn, Ch, 1);
              InString := InString + Ch;
            end;
          end else
          if (DLGhasLinefeeds) then Readln(F1, InString) else
          begin
            BlockRead(DLGBlockIn, InBuf, 1);
            InString := InBuf;
          end;
          setlength(LineRecord[Count].AAttributes,Length(InString));
          LineRecord[Count].AAttributes := InString;
        end;
      end else
      MessageDlgPos('Points this Line WRONG' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
    end; {IF Line=L}
    if (DLGhasLinefeeds) then DLGDone := EOF(F1) else
          DLGDone := EOF(DLGBlockIn);
  end; {EOF}
   {until ((Count=Lines)or (EOF(F1)));}
  str(LineCount, temp2);
  THints.Caption := 'Number of Lines Read ' + temp2;
  DILineOut.Text := temp2;
  IAttLEdit.Text:=InttoStr(MaxShapeAttributeLN);
  {--------------------}
  {Compute the Lines file size
    stuck in here kinda like points totals stuck in there}
  {--------------------}
  if (Shapetype = 3) then
  begin {Lines} {8 for X and Y points}
    {DLG only has 1 line per record
    DXF would have to count the number of Polylines per line,
    ...like islands in area}
            {28=24+4 (header)}
    ShapeFileSize :=
            ((Lines * 28) + (TotalLinePointSets * 8)+ 50);
    IndexFileSize := ((Lines * 4) + 50);
         {as 16 bit words, not 8 bit bytes}
          {(Each line set is a header,
            count stuff and the points) + Main header}
  end;
  DLGGauge.Position := 0;
  Application.ProcessMessages;
end; {ALL LINES for Shapetype Lines and Areas}
      {--------------------------------------------------------}
      {Compute the Areas file size}
      {--------------------------------------------------------}
THints.Caption := 'Computing Shape Areas';
if (Shapetype = 5) then
begin
  TotalShapePointSets := 0;
   {First area is number 1 even if skippering}
  for IIAreaCount := Skipper to (Areas{+Skipper-1} ) do
  begin
    {TwistedSister:=False;  first area skipped}
    str(IIAreaCount, temp);
    DIAreaOut.Text := temp;
    DLGGauge.Position :=(IIAreaCount div ((Areas div 100) +1));
    Application.ProcessMessages;
    IShp := AreaRecord[IIAreaCount].AreaLinesN;
    AreaRecord[IIAreaCount].NumberOfPoints := 0;
    SoManyPoints := 0;
    IslandCounter2 := 1;
    IslandHopperI := 0;
    {bIslandHopping:=False;
    IslandLine:=0;}
    {Every area (IIAreaCount)
     has a LOT of Lines (IAreaCount),
     that have a Lot of Points (IShape)}
    for IAreaCount := 0 to IShp - 1 do
    begin
      DoThisone :=((AreaRecord[IIAreaCount].ALines[IAreaCount]));
      {IF Negative then reverse.
       If 0 then do for island else add it in.}
      if (DoThisone < 0) then TwistedSister := True else
      TwistedSister := False;
      DoThisone := (abs(DoThisone));
      str(DoThisone, temp);
      DILineOut.Text := temp;
      Application.ProcessMessages;

      if (DoThisone = 0) then
      begin
        inc(MaxShapeIslandsCount);
        {    bIslandHopping:=True;
           IslandLine:=0;}
          {Islands only NEED to know where it IS...
           the points themselves are stored continuous}
        AreaRecord[IIAreaCount].IslandsArray[((IslandCounter2* 2))]
               := IslandCounter2;
        AreaRecord[IIAreaCount].IslandsArray[((IslandCounter2* 2) + 1)]
               := ((AreaRecord[IIAreaCount].NumberOfPoints) {})
            {NEXT ShapePoint of ZERO array not X+Y count};
        inc(IslandCounter2);
          {Check that the First point set
           is CLOSE to the First+1 point set
           else delete the farthest}
          {USDA puts in Island links back to Polygon}
        if (Sqrt(
                  Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[2 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[0 +
                    IslandHopperI])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[2 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[0 +
                    IslandHopperI])))
                  + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[1 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[3 +
                    IslandHopperI])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[1 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[3 +
                    IslandHopperI]))))
                  > (4 *
                  Sqrt(
                  Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[4 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[2 +
                    IslandHopperI])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[4 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[2 +
                    IslandHopperI])))
                  + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[3 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[5 +
                    IslandHopperI])
                  - Min(AreaRecord[IIAreaCount].ALinesPoints[3 +
                    IslandHopperI],
                  AreaRecord[IIAreaCount].ALinesPoints[5 +
                    IslandHopperI]))))))
        then bFirstTooLong := True else
        bFirstTooLong := False;
        {Check the (Next to last) end points of the island}
        if (Sqrt(
                  Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 2],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    4])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 2],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    4])))
                  +
                    Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 1],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    3])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 1],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    3]))))
                  > (4 *
                  Sqrt(
                  Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 4],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    6])
                  -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 4],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    6])))
                  +
                    Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 3],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    5])
                  -
                    Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints - 3],
                  AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints -
                    5]))))))
        then bLastTooLong := True else
           bLastTooLong := False;

          {bFirstTooLong bLastTooLong bBothTooLong}
        if ((bFirstTooLong) or (bLastTooLong)) then
        begin
            {If ((bFirstTooLong)and (bLastTooLong))then
             bBothTooLong :=True else bBothTooLong:=False;}
          if (bFirstTooLong) then StartingPoint := (2) else
              StartingPoint := (0);
          if (bLastTooLong) then
               FinishingPoint := ({-} 2) else
               FinishingPoint := (0);
          DoThisMany := ((((SoManyPoints - 1)
                    - FinishingPoint)
                    - StartingPoint)
                    - IslandHopperI);
          ISoManyPoints := 0 + StartingPoint;
          for IShape := 0 to DoThisMany - 1 do
          begin
            AreaRecord[IIAreaCount].ALinesPoints[IShape +IslandHopperI]
              := AreaRecord[IIAreaCount].ALinesPoints[ISoManyPoints + IslandHopperI];
            inc(ISoManyPoints);
          end; {ISoManyPoints}

          SoManyPoints := ((SoManyPoints - FinishingPoint) -
                    StartingPoint);
          TotalShapePointSets := ((TotalShapePointSets -
                    (FinishingPoint div 2))
                    - (StartingPoint div 2));
            {IslandHopperI:=((IslandHopperI-FinishingPoint)-StartingPoint);}
            {IslandHopperI:=((SoManyPoints-2)-IslandHopperI);}


          AreaRecord[IIAreaCount].NumberOfPoints :=
                 ((AreaRecord[IIAreaCount].NumberOfPoints
                    - (FinishingPoint div 2))
                    - (StartingPoint div 2));
            {Redo to increase for added point, set back-1 due to counter }
          AreaRecord[IIAreaCount].IslandsArray[(((IslandCounter2 - 1) * 2) + 1)] :=
                    ((AreaRecord[IIAreaCount].NumberOfPoints) {})
        end; {BFirst}
          {Check that the FIRST point
          is the same as the LAST point in an area}
        if (AreaRecord[IIAreaCount].ALinesPoints[0 +
                  IslandHopperI] <>
                  AreaRecord[IIAreaCount].ALinesPoints[((SoManyPoints
                    - 2) {-IslandHopperI})])
        then
        begin
          {str(AreaRecord[IIAreaCount].ALinesPoints[0+IslandHopperI]:24:8,temp2);
               str(AreaRecord[IIAreaCount].ALinesPoints
              [((SoManyPoints-2)-IslandHopperI)]:24:8,temp);
               DLGMemo.Lines.Add(temp2+' <> '+temp);
                str(IIAreaCount,temp);
                DLGMemo.Lines.Add('Added an Island Area ender to '+temp);}
          AreaRecord[IIAreaCount].NumberOfPoints :=
               (AreaRecord[IIAreaCount].NumberOfPoints + 1);
          setlength(AreaRecord[IIAreaCount].ALinesPoints,
                (AreaRecord[IIAreaCount].NumberOfPoints * 2)
                  {ShapePoints*2});
            {IF (  AreaRecord[IIAreaCount].ALinesPoints[0+IslandHopperI] <>
                AreaRecord[IIAreaCount].ALinesPoints[((SoManyPoints-2)-IslandHopperI)])}
          AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints
                    {-IslandHopperI}] :=
                    AreaRecord[IIAreaCount].ALinesPoints[0 +
                      IslandHopperI];
          inc(SoManyPoints);
          AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints
                    {-IslandHopperI}] :=
                    AreaRecord[IIAreaCount].ALinesPoints[1 +
                      IslandHopperI];
          inc(SoManyPoints);
          inc(TotalShapePointSets);
          inc(TotalPointsAdded);

            {Redo to increase for added point, set back-1 due to counter }
          AreaRecord[IIAreaCount].IslandsArray[(((IslandCounter2 - 1) * 2) + 1)] :=
                    ((AreaRecord[IIAreaCount].NumberOfPoints) {})
            {NEXT ShapePoint of ZERO array not X+Y count};

           {Check distance of 1..2 and 2..3}
        end;
{IHOP ?}IslandHopperI := ((SoManyPoints - 2) - IslandHopperI);
      end else
      begin
          {Gotta find THAT line, as not in any order... from area}
        DoThisoneI := 0;
        for Incrementer := 1 to Lines do
        begin
          if (LineRecord[Incrementer].LineNumber = DoThisone) then
            DoThisoneI := Incrementer;
        end;
        if (DoThisoneI = 0) then
        begin
          DoRezError(14);
          exit;
        end;
          {TotalShapePointSets is Total for ALL Areas}
        TotalShapePointSets :=
                (TotalShapePointSets +
                  (LineRecord[DoThisoneI].NumberOfPoints));
        AreaRecord[IIAreaCount].NumberOfPoints :=
                  (AreaRecord[IIAreaCount].NumberOfPoints
                  + LineRecord[DoThisoneI].NumberOfPoints);
        DoThisMany :=
                 ((LineRecord[DoThisoneI].NumberOfPoints));
        setlength(AreaRecord[IIAreaCount].ALinesPoints,
                  (AreaRecord[IIAreaCount].NumberOfPoints * 2)
                    {ShapePoints*2});

(*
        {check first line}
{    If (IAreaCount= 0 ) then begin
    If (LineRecord[DoThisoneI].LinesPoints[0] >
        LineRecord[DoThisoneI].LinesPoints[2])
    then TwistedSister:=True else TwistedSister:=False;
    end else}
    If ((IAreaCount > 0 ) and(bIslandHopping=false) )then begin
    { next area line... do check}
     {  Distance:=Sqrt(Sqr(P1.X - P2.X) + Sqr(P1.Y - P2.Y));}
       If (Sqrt(
             Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[0])
                   -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[0]) ))
           + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                      LineRecord[DoThisoneI].LinesPoints[1])
                   -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                      LineRecord[DoThisoneI].LinesPoints[1]) )) )
          >
          Sqrt(
            Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                     LineRecord[DoThisoneI].LinesPoints[DoThisMany-2])
                    -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[DoThisMany-2]) ))
          + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                  LineRecord[DoThisoneI].LinesPoints[DoThisMany-1])
                -Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                  LineRecord[DoThisoneI].LinesPoints[DoThisMany-1]) )) ))
        then TwistedSister:=True else TwistedSister:=False;
    end else {First island line}
    If ((IslandLine = 0 ) and(bIslandHopping=true) )then begin
    {Check that the island is backwards}
     inc(IslandLine);
    If (LineRecord[DoThisoneI].LinesPoints[0] <
        LineRecord[DoThisoneI].LinesPoints[2])
    then TwistedSister:=True else TwistedSister:=False;
    end else {second or more island line}
    If ((IslandLine > 0 ) and(bIslandHopping=true) )then begin
    {Check the (Next to last) end points of the island}
      If (Sqrt(
             Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[0])
                   -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[0]) ))
           + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                      LineRecord[DoThisoneI].LinesPoints[1])
                   -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                      LineRecord[DoThisoneI].LinesPoints[1]) )) )
          >
          Sqrt(
            Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                     LineRecord[DoThisoneI].LinesPoints[DoThisMany-2])
                    -
                  Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-2],
                      LineRecord[DoThisoneI].LinesPoints[DoThisMany-2]) ))
          + Sqr((Max(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                  LineRecord[DoThisoneI].LinesPoints[DoThisMany-1])
                -Min(AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints-1],
                  LineRecord[DoThisoneI].LinesPoints[DoThisMany-1]) )) ))
        then TwistedSister:=True else TwistedSister:=False;
    end else TwistedSister:=False;
*)

        if (TwistedSister) then
        begin
          for IShape := DoThisMany - 1 downto 0 do
          begin
            {Switch the X+Ys}
            AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints]
                      :=
                      LineRecord[DoThisoneI].LinesPoints[(IShape * 2)];
            inc(SoManyPoints);
            AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints]
                      :=
                LineRecord[DoThisoneI].LinesPoints[(IShape * 2)+ 1];
            inc(SoManyPoints);
          end; {IShape}
        end else
        begin
          DoThisMany := (DoThisMany * 2);
          for IShape := 0 to DoThisMany - 1 do
          begin
            AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints]
                      :=
                      LineRecord[DoThisoneI].LinesPoints[IShape];
            inc(SoManyPoints);
          end; {IShape}
        end; {TwistedSister}

        if (SoManyPoints > 2147483600) then DoRezError(15);
      end; {Do = 0}
    end; {IAreaCount}
      {Still gotta check if there were NO islands
      that the polygon is a circle}
    if (AreaRecord[IIAreaCount].IslandsN = 0) then
    begin
      if (AreaRecord[IIAreaCount].ALinesPoints[0] <>
          AreaRecord[IIAreaCount].ALinesPoints[(SoManyPoints -2)])
      then
      begin
          {  str(AreaRecord[IIAreaCount].ALinesPoints[0]:24:8,temp);
           str(AreaRecord[IIAreaCount].ALinesPoints[((SoManyPoints-2))]:24:8,temp2);
           DLGMemo.Lines.Add(temp+' <> '+temp2);}
          {  str(IIAreaCount,temp);
           DLGMemo.Lines.Add('Added an Area ender to '+temp);}
        AreaRecord[IIAreaCount].NumberOfPoints :=
                  (AreaRecord[IIAreaCount].NumberOfPoints + 1);
        setlength(AreaRecord[IIAreaCount].ALinesPoints,
                  (AreaRecord[IIAreaCount].NumberOfPoints * 2)
                    {ShapePoints*2});
        AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints] :=
                  AreaRecord[IIAreaCount].ALinesPoints[0];
        inc(SoManyPoints);
        AreaRecord[IIAreaCount].ALinesPoints[SoManyPoints] :=
                  AreaRecord[IIAreaCount].ALinesPoints[1];
        inc(TotalShapePointSets);
        inc(TotalLinePointsAdded);
      end;
    end; {Area islands=0}
  end;
  {File computation IS different than computing RECORD sizes}
  {IIAreaCount} {22+2(1 ring)   (+4 header)}
  ShapeFileSize := ( (((Areas+1) - Skipper) * 28)
     {They ALL have 1 ring, some have more, so count islands separate}
            + (TotalShapeIslandsN * 2) {Islands pointers }
            + (TotalShapePointSets * 8)
            + 50);
  IndexFileSize := ((((Areas+1) - Skipper) * 4) + 50);
     {(Each point set is a header and the points) + Main header}
  DLGMemo.Lines.Add(Inttostr(ShapeFileSize)
           + ' Index ' + Inttostr(IndexFileSize));
  DLGMemo.Lines.Add(Inttostr(TotalShapeIslandsN)
           + ' <Islands..Points> ' + Inttostr(TotalShapePointSets));
end;
{---------------------------------------------------------------------}
{Points do NOT have attributes.... ?}
if ((Shapetype = 1) and (bDLGAttSymCB)) then
begin
  DoRezError(21);
  exit; {Exit is quit doing this procedure}
end;
{Multi Points do NOT have attributes.... ?}
if ((Shapetype = 8) and (bDLGAttSymCB)) then
begin
  DoRezError(21);
  exit;{Exit is quit doing this procedure}
end;

{---------------------------------------------------------------------}
if (bDLGAttSymCB) then
begin
  atemp := {DLGPath+ShapeNameEdit.Text;}
          ChangeFileExt(TempName,'.sat');
         { atemp[Length(atemp)] := 'a';
          atemp[Length(atemp) - 4] := 'a'; }
  {Import extra attributes...}
  if FileExists(ChangeFileExt(TempName, '.att')) then
  begin
    bDLGAtt := True;              {Natsgo}
    temp := ChangeFileExt(TempName, '.att');
    AssignFile(AttSymFile, temp);
    Reset(AttSymFile);
    {This leaves it open until read during Shape write}
    {Skip the first record}
    For Incrementer:= 2 to Skipper do
    {if (Skipper = 1) then} Readln(AttSymFile, Instring);
    {NRI
    State
     xxRegion    (HUC, MLRA or FED, FIPS,
         ???.dlg are the DLG area records w/Maj+Min
         ???.sym are the nriptr link attributes by area #
                 .. not linked to Maj-Min codes
           1 UNIV
           2 09030009 ...
     XX(State).TAB Point data records  XX.tab -not DLG points
       Soils records... ~14 record types     }
  end else {begin       }
  if FileExists(ChangeFileExt(TempName,'.sym')) then
  begin
    bDLGSym := True;
    temp := ChangeFileExt(TempName, '.sym');
    AssignFile(AttSymFile, temp);
    Reset(AttSymFile);
    SymArrayCounter := 0;
    while (not eof(AttSymFile)) do
    begin
      Readln(AttSymFile, InString);
      inc(SymArrayCounter);
    end;
    Reset(AttSymFile);
    SetLength(SymArray, SymArrayCounter+1);{extra space}
    SymArrayCounter := 0;
    while (not eof(AttSymFile)) do
    begin
      Readln(AttSymFile, InString);
      SetLength(SymArray[SymArrayCounter],
      Length(InString));
      SymArray[SymArrayCounter] := InString;
      inc(SymArrayCounter);
    end;
    CloseFile(AttSymFile);
    {Get them into an array
       so a case of dlg attribute can find
       the relative text to add as MUID}
      {STATSGO
       XX(State)
        Spatial   XX.DLG  XX.SYM
                  list of links(~82 MUID's) to DLG minor attributes
        Metadata
        Header
        Tabular  Soils records... ~16 record types
                 MAPUNIT links to the rest of them through MUID }
  end {File exists}
  else if FileExists(atemp) then
       {Import SSURGO extra attributes...}
  begin
      {showmessage('ssurgo');}
    bDLGXaa := True;
    AssignFile(AttSymFile, atemp);
    Reset(AttSymFile);
    Readln(AttSymFile, AttSymstring);{All 1 line}
    CloseFile(AttSymFile);
       {SSurgo is TAB Delimited... Skip first now}
        {Skip the first Skipper records}
    For Incrementer:= 2 to Skipper do
    begin
      IChar := Pos(#9, AttSymstring);
      temp2 := Copy(AttSymstring, IChar,length(AttSymstring));
      if (temp2[1] = #9) then temp2[1] := ' ';
      temp := trim(temp2); {Skip 1}
      IChar := Pos(#9, temp);
      temp2 := Copy(temp, IChar, length(temp));
      if (temp2[1] = #9) then temp2[1] := ' ';
      temp := trim(temp2); {Skip 1}
      temp2 := temp; {Skip2}
      IChar := Pos(#9, temp);
      InString := Copy(temp, 1, IChar);
      temp := trim(InString);
      if (length(temp) = 0) then temp := '0';
      val(temp, II, ErrorCode);
       {put Minor in db
                dbTable.FieldValues['MINOR'] := II;}
      temp2 := Copy(temp2, IChar, length(temp2));
      if (temp2[1] = #9) then temp2[1] := ' ';
      temp := trim(temp2);
      temp2 := temp;{Skip3}
      IChar := Pos(#10, temp);
      if (IChar = 0) then IChar := length(temp);
      InString := Copy(temp, 1, IChar);
      temp := trim(InString);
      if (length(temp) = 0) then temp := '0';
      {put MUID in db
                dbTable.FieldValues['MUID'] := temp;}
      temp2 := Copy(temp2, IChar, length(temp2));
      if (temp2[1] = #10) then temp2[1] := ' ';
      temp := trim(temp2);
      AttSymstring := temp; {put back for next loop}
    end;
      {SSURGO by county... 198 xaf+xaa etc..
        files for St. Clair IL tab
        26 tabular soils files
        dlg
        xaf: dlg... 459 areas with Major+minor codes
        xaa: 1 Major Minor SoilType|...459 Major Minor SoilType|}
  end else DoRezError(5);
end;

      {---------------------------------------------------}
       {This happens NO MATTER WHAT}
      {---------------------------------------------------}
{str(MaxShapeAttributeLN, temp);}
IAttLEdit.Text := InttoStr(MaxShapeAttributeLN);
{str(MaxShapeAttributePN, temp);}
IAttLEdit.Text := InttoStr(MaxShapeAttributePN);
{str(MaxShapeAttributeN, temp); }
IAttLEdit.Text := InttoStr(MaxShapeAttributeN);
If (MaxShapeAttributeLN > MaxShapeAttributeN) then
      MasterMaxShapeAttributeN := MaxShapeAttributeLN else
  if (MaxShapeAttributePN > MaxShapeAttributeN) then
      MasterMaxShapeAttributeN := MaxShapeAttributePN else
      MasterMaxShapeAttributeN := MaxShapeAttributeN;

  {------------------------------------------------------}
  {RunTimeDbCreate(const DatabaseName, SessionName: String): TDatabase;}
  {The following code fragment illustrates how you might
   call this function to create a database component
   for the default session at runtime:}
MyDatabase[MyDbCount] :=
          RunTimeDbCreate('sshift' + IntToStr(MyDbCount), '');
  { Later, create a database component at runtime }
   {Make a database table}
dbTable := TTable.Create(Transformer);
with dbTable do
begin
  Active := False;
  DatabaseName := 'sshift' + IntToStr(MyDbCount);
  TableType := ttDBase; {DBase for Shape files}
  TableName :=ChangeFileExt(ShapePath + ShapeNameEdit.Text,'.dbf');
  with FieldDefs do
  begin
    Clear;
    {If Statsgo}
    if (bDLGSym) then
    begin
      if (bDLGNumberItemsCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'COUNTI';
          DataType := ftInteger; {Required := True;}
        end;
      end;
      with AddFieldDef do
      begin
        Name := 'MINORI';
        DataType := ftInteger; {Required := True;}
      end;
      with AddFieldDef do
      begin
        Name := 'MUIDS'; {ftString  ftFixedChar}
        DataType := ftString; { Required := True;}
        Size := 7;
      end;
      if (bAddMapAttributesCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'MAPI';
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MAPF';
          DataType := ftFloat; {Required := True;}
        end;
      end;
    end else
    {Natsgo}
    if (bDLGAtt) then
    begin
      if (bDLGNumberItemsCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'COUNTI';
          DataType := ftInteger; {Required := True;}
        end;
      end;
        {with AddFieldDef do begin
                  Name := 'MINOR';
                   DataType := ftInteger;
                   end;  ... NO DLG Codes in DLG or ATT file}
      temp2 := Uppercase(ExtractFileName(TempName));
            {MW_?...}
      temp := temp2[4];
      if temp = 'L' then
      begin
        with AddFieldDef do
        begin
          Name := 'MLRAS';
          DataType := ftString; { Required := True;}
          Size := 4;
        end;
      end else
      if temp = 'E' then
      begin
        with AddFieldDef do
        begin
          Name := 'MLRAS'; {Federal lands}
          DataType := ftString; { Required := True;}
          Size := 4;
        end;
      end else
      if temp = 'I' then
      begin
        with AddFieldDef do
        begin
          Name := 'FIPSS'; {NRIPTR}
          DataType := ftString; { Required := True;}
          Size := 5;
        end;
      end else
      if temp = 'U' then
      begin
        with AddFieldDef do
        begin
          Name := 'HYDROS'; {HUC}
          DataType := ftString; { Required := True;}
          Size := 8;
        end;
      end;
      if (bAddMapAttributesCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'MAPI';
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MAPF';
          DataType := ftFloat; {Required := True;}
        end;
      end;
      {SSurgo}
    end else
    if (bDLGXaa) then
    begin
      {showmessage('ssurgo 2');}
      if (bDLGNumberItemsCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'COUNTI';
          DataType := ftInteger; {Required := True;}
        end;
      end;
      with AddFieldDef do
      begin
        Name := 'MINORI';
        DataType := ftInteger; {Required := True;}
      end;
      with AddFieldDef do
      begin
        Name := 'MUIDS';
        DataType := ftString; { Required := True;}
        Size := 7;
      end;
      if (bAddMapAttributesCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'MAPI';
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MAPF';
          DataType := ftFloat; {Required := True;}
        end;
      end;
    end else

{NOT A SOILS database and what ever box is checked}
    if ((bDLGMinorCodesCB)
           or (bDLGSingleCodeCB)) then
    begin
      if (bDLGNumberItemsCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'COUNT';
          DataType := ftInteger; {Required := True;}
        end;
      end;
      if (bDLGMinorCodesCB)then
      begin
      for Incrementer := 1 to MasterMaxShapeAttributeN do
      begin
        with AddFieldDef do
        begin
          str(Incrementer, tempstr);
          Name := 'MINOR' + tempStr;
          DataType := ftInteger; {Required := True;}
        end;
      end;
      end else
      begin
        with AddFieldDef do
        begin
          Name := 'MINOR';
          DataType := ftInteger; {Required := True;}
        end;
      end;
      if (bAddMapAttributesCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'MAPI';
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MAPF';
          DataType := ftFloat; {Required := True;}
        end;
      end;
    end else
{Whatever with nothing check boxed}
    if ((bNothingChecked)) then
    begin
      if (bDLGNumberItemsCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'COUNT';
          DataType := ftInteger; {Required := True;}
        end;
      end;
        with AddFieldDef do
        begin
          Name := 'MAJOR' ;
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MINOR';
          DataType := ftInteger; {Required := True;}
        end; {add}
      {If Map attributes}
      if (bAddMapAttributesCB) then
      begin
        with AddFieldDef do
        begin
          Name := 'MAPI';
          DataType := ftInteger; {Required := True;}
        end;
        with AddFieldDef do
        begin
          Name := 'MAPF';
          DataType := ftFloat; {Required := True;}
        end;
      end;
    end else {last one}
     {}
{NOT A SOILS database and what would cause this?}
    If (MasterMaxShapeAttributeN = 0) then
    begin
      with AddFieldDef do
      begin
        Name := 'COUNT';
        DataType := ftInteger; {Required := True;}
      end;
    end;
  end; {Fielddefs}
    { Next, describe any indexes ... dBase table so NO INDEX}
  CreateTable;
end;

dbTable.Active := True;

   {------------------------------------------------------------}
        {just checking to see if ok to go on}
        if (not dbTable.Exists) then DoRezError(8);

        {Set up Shape and Index file}
        temp := ChangeFileExt(DLGShapeFileName, '.shx');
        AssignFile(IndexFileOut, temp);
        Rewrite(IndexFileOut, 1);
        AssignFile(ShapeFileOut, DLGShapeFileName);
        Rewrite(ShapeFileOut, 1);
        DLGGauge.Position := 0;

        SwapShapeInteger(9994);
        SwapIndexInteger(9994);
        for Incrementer := 1 to 5 do
        begin {5 blank zeros}
          SwapShapeInteger(0);
          SwapIndexInteger(0);
        end;
        SwapShapeInteger(ShapeFileSize); {File size}
        SwapIndexInteger(IndexFileSize);

        ShapeInteger := 1000; {Version}
        BlockWrite(ShapeFileOut, ShapeInteger, 4);
        BlockWrite(IndexFileOut, ShapeInteger, 4);
         {Shapetype}
        BlockWrite(ShapeFileOut, Shapetype, 4);
        BlockWrite(IndexFileOut, Shapetype, 4);
        {XMIN,YMIN,XMAX,YMAX:Double;}
        BlockWrite(ShapeFileOut, dXMIN, 8);
        BlockWrite(IndexFileOut, dXMIN, 8);
        BlockWrite(ShapeFileOut, dYMIN, 8);
        BlockWrite(IndexFileOut, dYMIN, 8);
        BlockWrite(ShapeFileOut, dXMAX, 8);
        BlockWrite(IndexFileOut, dXMAX, 8);
        BlockWrite(ShapeFileOut, dYMAX, 8);
        BlockWrite(IndexFileOut, dYMAX, 8);
        {M and Z Min and MAx} {Byte 68..100}
        XTemp:=0.0;
        for Incrementer := 1 to 4 do
        begin
        BlockWrite(ShapeFileOut, XTemp, 8);
        BlockWrite(IndexFileOut, XTemp, 8);
        end;


{--------------------------------------------------------------}
{Write a shape file of Points}
{--------------------------------------------------------------}
THints.Caption := 'Writing Shape File';
if (Shapetype = 1) then
begin {Read in Points}
  Count := 0;
  PointCount := 0;
  IndexOffset := 50;
  if Points > 0 then
  begin
    if (DLGhasLinefeeds) then Reset(F1) else
    if (DLGhasCrReturns) then Reset(DLGBlockIn, 1)
    else Reset(DLGBlockIn, 80);
    DLGDone := False;
    while ((not DLGDone)) do
    begin
      if (DLGhasLinefeeds) then Readln(F1, InString) else
      begin
        BlockRead(DLGBlockIn, InBuf, 1);
        InString := InBuf;
      end;
      if InString[1] = 'N' then
      begin {Get number of points per line}
        inc(Count);
        DLGGauge.Position :=(Count div ((Points div 100) + 1));
        Application.ProcessMessages;
        temp := Copy(InString, 8, 11);
        Val(temp, XTemp, ErrorCodex);
        if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
        temp2 := Copy(InString, 20, 11);
        Val(temp2, YTemp, ErrorCodey);
        if (ErrorCodey > 0) then Codefx(temp2, ErrorCodey);
        if ((ErrorCodex = 0) and (ErrorCodey = 0)) then
        begin
          SwapShapeInteger(Count);
          {Record Number starts with 1}
          {Offset incremented for start of NEXT one}
          SwapIndexInteger(IndexOffset);
          IndexOffset := IndexOffset + 14;
           {Index offset + Content Length +header}
          SwapShapeInteger(10);
           {Content Length.. not content + header}
          SwapIndexInteger(10);
          ShapeInteger := (ShapeType); {Shape Type=1}
          BlockWrite(ShapeFileOut, ShapeInteger, 4);
          BlockWrite(ShapeFileOut, XTemp, 8); {X}
          BlockWrite(ShapeFileOut, YTemp, 8); {Y}
          temp := Copy(InString, 49, 6);
          Val(temp, ShapeAttributePN, ErrorCodex);
             {# of attributes}
          if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          if (MasterMaxShapeAttributeN = 0) then
          begin
            dbTable.Append;
            dbTable.FieldValues['COUNT'] := Count;
            dbTable.Post;
          end else
          begin
            {to get the attribute line}
            if (DLGhasLinefeeds) then Readln(F1, InString) else
            begin
              BlockRead(DLGBlockIn, InBuf, 1);
              InString := InBuf;
            end;
            if (Count < 3) then DLGMemo.Lines.Add(InString); {FYI}
            dbTable.Append;
            {Get the Attributes}
            for Incrementer := 0 to ShapeAttributePN - 1 do
            begin
              temp2 := Copy(InString, (1 + (Incrementer * 12)), 6);
              temp := trim(temp2);
              Val(temp, ShapeAttributeN2, ErrorCodex);
              if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
              if (not (bDLGSingleCodeCB)) then
              begin
                temp2 := Copy(InString, (1 + (Incrementer * 12) + 6),6);
                temp := trim(temp2);
                Val(temp, ShapeAttributeN3, ErrorCodex);
                if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
              end;
              {Decide how to put em in DB}
              if bDLGSingleCodeCB then
              begin
                if (bDLGNumberItemsCB) then
                  dbTable.FieldValues['COUNT'] := Count;
                str(Incrementer + 1, tempstr);
                dbTable.FieldValues['MINOR' + tempStr] :=
                   ShapeAttributeN2;
              end else
              if ((bDLGMinorCodesCB)) then
              begin
                if (bDLGNumberItemsCB) then
                    dbTable.FieldValues['COUNT'] := Count;
                str(Incrementer + 1, tempstr);
                dbTable.FieldValues['MINOR' + tempStr] :=
                    ShapeAttributeN3;
              end else
              begin {}
                if (bDLGNumberItemsCB) then
                   dbTable.FieldValues['COUNT'] := Count;
                str(Incrementer + 1, tempstr);
                dbTable.FieldValues['MAJOR' + tempStr] :=
                   ShapeAttributeN2;
                dbTable.FieldValues['MINOR' + tempStr] :=
                   ShapeAttributeN3;
              end; {which box checked}
            end; {I:=0}
            dbTable.Post;
          end; {Attributing}
          inc(PointCount);
        end {error Code} else
        begin {Display incorrect points}
          DLGMemo.Lines.Add(InString);
          MessageDlgPos('Bad Points x ' + temp
                      + ' y ' + temp2, mtError,[mbOK],
                      0, MessageX, MessageY);
        end;
      end; {Instring=N}
      if (DLGhasLinefeeds) then DLGDone := EOF(F1)
         else DLGDone := EOF(DLGBlockIn);
    end; {while not EOF}
  end; {Points >0}
  str(PointCount, temp);
  THints.Caption := 'Points correctly read ' + temp;
  DIPointOut.Text := temp;
end {Shape type 1} else
{-------------------------------------------------------------}
{Write the lines to a shape file}
{-------------------------------------------------------------}
if (Shapetype = 3) then
begin
  PointCount := 0;
  IndexOffset := 50;
  if Lines > 0 then
  begin
    for Count := 1 to Lines do
    begin
      DLGGauge.Position :=
          (Count div ((Lines div 100) + 1));
      Application.ProcessMessages;
      TotalShapePointSets :=
                 ((LineRecord[Count].NumberOfPoints));
      SwapShapeInteger(Count); {Record Number}
      SwapIndexInteger(IndexOffset);
      {Index offset + Content Length... for NEXT record... first is 50}
      RecordSize := (24 + (TotalShapePointSets * 8));
        {Content Length}
      IndexOffset := (IndexOffset + RecordSize + 4);
        {Index is Index+content+4 (header)}
      SwapShapeInteger(RecordSize);
      SwapIndexInteger(RecordSize);
      ShapeInteger := (ShapeType); {Shape Type=3}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      DoThisMany := ((LineRecord[Count].NumberOfPoints));
      LinePointCount := 0;
      XTemp :=LineRecord[Count].LinesPoints[LinePointCount];
      XMax := XTemp;
      XMin := XTemp;
      inc(LinePointCount);
      YTemp :=LineRecord[Count].LinesPoints[LinePointCount];
      YMax := YTemp;
      YMin := YTemp;
      inc(LinePointCount);
      for IShape := 1 to DoThisMany - 1 do
      begin
        XTemp :=
            LineRecord[Count].LinesPoints[LinePointCount];
        if (XTemp >= XMax) then XMax := XTemp;
        if (XTemp <= XMin) then XMin := XTemp;
        inc(LinePointCount);
        YTemp :=
           LineRecord[Count].LinesPoints[LinePointCount];
        if (YTemp >= YMax) then YMax := YTemp;
        if (YTemp <= YMin) then YMin := YTemp;
        inc(LinePointCount);
      end;
      BlockWrite(ShapeFileOut, XMin, 8); {X min}
      BlockWrite(ShapeFileOut, YMin, 8); {Y min}
      BlockWrite(ShapeFileOut, XMax, 8); {X max}
      BlockWrite(ShapeFileOut, YMax, 8); {Y max}
      {Number of Parts... poly lines in the arc... 1}
      {This is here for DXF CAD files, DLGs only have 1 line}
      ShapeInteger := (1);
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Number of Points for ALL polylines... X and Y}
      ShapeInteger := (TotalShapePointSets);
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Parts index pointer for start of each line... 0}
      ShapeInteger := (0);
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      DoThisMany := ((LineRecord[Count].NumberOfPoints));
      LinePointCount := 0;
      for IShape := 0 to DoThisMany - 1 do
      begin
        XTemp :=LineRecord[Count].LinesPoints[LinePointCount];
        BlockWrite(ShapeFileOut, XTemp, 8); {X}
        inc(LinePointCount);
        YTemp :=LineRecord[Count].LinesPoints[LinePointCount];
        BlockWrite(ShapeFileOut, YTemp, 8); {Y}
        inc(LinePointCount);
      end;
      if (MasterMaxShapeAttributeN = 0) then
      begin
        dbTable.Append;
        dbTable.FieldValues['COUNT'] := Count;
        dbTable.Post;
      end else
      begin
        dbTable.Append;
        InString := LineRecord[COUNT].AAttributes;
        ShapeAttributeLN := LineRecord[Count].AttributeN;
        for Incrementer := 0 to ShapeAttributeLN - 1 do
        begin
          temp := Copy(InString, (1 + (Incrementer * 12)), 6);
          Val(temp, ShapeAttributeN2, ErrorCodex);
          if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          if (not (bDLGSingleCodeCB)) then
          begin
            temp2 := Copy(InString, (1 + (Incrementer * 12) + 6), 6);
            temp := trim(temp2);
            Val(temp, ShapeAttributeN3, ErrorCodex);
            if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          end;
          if bDLGSingleCodeCB then
          begin
            if (bDLGNumberItemsCB) then
                dbTable.FieldValues['COUNT'] := Count;
            {str(I + 1, tempstr);}
            dbTable.FieldValues['MINOR' ] :=
            ShapeAttributeN2;
          end else
          if bDLGMinorCodesCB then
          begin
            if (bDLGNumberItemsCB) then
               dbTable.FieldValues['COUNT'] := Count;
            str(Incrementer + 1, tempstr);
            dbTable.FieldValues['MINOR' + tempStr] :=
                    ShapeAttributeN3;
          end else
          begin {}
            if (bDLGNumberItemsCB) then
                  dbTable.FieldValues['COUNT'] := Count;
            {str(I + 1, tempstr);}
            dbTable.FieldValues['MAJOR' ] :=
                   ShapeAttributeN2;
            {str(I + 2, tempstr);}
            dbTable.FieldValues['MINOR'] :=
                   ShapeAttributeN3;
          end;
        end;
       dbTable.Post;
      end;
      inc(PointCount);
    end;
  end;
  str(PointCount, temp);
  THints.Caption := 'Lines correctly read ' + temp;
  DILineOut.Text := temp;
end else
      {---------------------------------------------------------------------}
       {Write the areas to a shape file}
       {if not((bDLGSym) or (bDLGAtt) or (bDLGXaa)) then
        showmessage('Nothing done');}
      {--------------------------------------------------------}

if (Shapetype = 5) then
begin

  DLGGauge.Position :=0;
  {Each record has a header:
  Record number (starts at 1) and Content Length at 50}
  {Read all the areas, all the lines
  Make polygons from the lists of lines in each polygon}
  {Each island has a Zero record before it}
  temp2NRI :=Uppercase(ExtractFileName(TempName));
           {MW_?...}
  temp2NRI := temp2NRI[4];
  PointCount := 1;
  PointCountTotal := 1;
  IndexOffset := 50;
  IndexOffsetTotal := 50;
  if Areas > 0 then
  begin
    for Count := Skipper to (Areas ) do
    begin
      DLGGauge.Position := (Count div ((Areas div 100) + 1));
      Application.ProcessMessages;
      TotalShapePointSets :=
                    ((AreaRecord[Count].NumberOfPoints));
      {Record Number}
      PointCount:=PointCountTotal;
      SwapShapeInteger(PointCount);
      {Index offset + Content Length, first is 50, rest get incremented}
      IndexOffset := IndexOffsetTotal;
      SwapIndexInteger(IndexOffset);
      {Content Length for next record}
      RecordSize := (22 +
                    {Islands pointers }
                    (((AreaRecord[Count].IslandsN) + 1) * 2)
                    + (TotalShapePointSets * 8)
                    {+4}{this header data});
              {Index is Index+content+4 (header)}
      {IndexOffset := (IndexOffset + I + 4); }
      IndexOffsetTotal:=(IndexOffsetTotal + RecordSize + 4);{for next one}
      SwapShapeInteger(RecordSize);{This offset size}
      SwapIndexInteger(RecordSize);
{  From above
  IIAreaCount 22+2(1 ring)+4 header
  ShapeFileSize := ( (((Areas+1) - Skipper) * 28)
     They ALL have 1 ring, some have more, so count islands separate
            + (TotalShapeIslandsN * 2) Islands pointers
            + (TotalShapePointSets * 8)
            + 50);
  IndexFileSize := ((((Areas+1) - Skipper) * 4) + 50);
}


      ShapeInteger := (ShapeType); {Shape Type}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      LinePointCount := 0;
      XTemp :=AreaRecord[Count].ALinesPoints[LinePointCount];
      XMax := XTemp;
      XMin := XTemp;
      inc(LinePointCount);
      YTemp :=AreaRecord[Count].ALinesPoints[LinePointCount];
      YMax := YTemp;
      YMin := YTemp;
      inc(LinePointCount);
{}
      DoThisMany := ((AreaRecord[Count].NumberOfPoints));
      for IShape := 1 to DoThisMany - 1 do
      begin
        {This doubles the point count internally}
        XTemp :=
              AreaRecord[Count].ALinesPoints[LinePointCount];
        if (XTemp >= XMax) then XMax := XTemp;
        if (XTemp <= XMin) then XMin := XTemp;
        inc(LinePointCount);
        YTemp :=
             AreaRecord[Count].ALinesPoints[LinePointCount];
        if (YTemp >= YMax) then YMax := YTemp;
        if (YTemp <= YMin) then YMin := YTemp;
        inc(LinePointCount);
      end; {IShape}
      BlockWrite(ShapeFileOut, XMin, 8); {X min}
      BlockWrite(ShapeFileOut, YMin, 8); {Y min}
      BlockWrite(ShapeFileOut, XMax, 8); {X max}
      BlockWrite(ShapeFileOut, YMax, 8); {Y max}
{}
       {Number of Parts... rings in the polygon... }
      ShapeInteger := ((AreaRecord[Count].IslandsN) + 1);
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Number of Points for this line}
      ShapeInteger := (TotalShapePointSets);
      {2 points per ShapePoint}
      BlockWrite(ShapeFileOut, ShapeInteger, 4);
      {Parts index pointer for start of each line... 0}
      if (AreaRecord[Count].IslandsN = 0) then
      begin
        ShapeInteger := (0);
        BlockWrite(ShapeFileOut, ShapeInteger, 4);
      end else
      begin
        {Island Index Counter is ALL that determines Rings of a Polygon}
        ShapeInteger := (0);
        BlockWrite(ShapeFileOut, ShapeInteger, 4);
        {Do first ^ and then any-all the others}
        for Incrementer := 1 to AreaRecord[Count].IslandsN do
        begin
          {Indexed into points array,Point #, not its size, nor X+Y count,
           not the content length, etc...}
{THIS IS WRONG??}
          ShapeInteger :=
           (((AreaRecord[Count].IslandsArray[((Incrementer * 2) +1)])));
{           (((AreaRecord[Count].IslandsArray[((Incrementer ) +1)])));}
          BlockWrite(ShapeFileOut, ShapeInteger, 4);
        end;
      end; {AreaRecord Islands}
{}
      DoThisMany := ((AreaRecord[Count].NumberOfPoints));
      LinePointCount := 0;
      for IShape := 0 to DoThisMany - 1 do
      begin
        XTemp :=
             AreaRecord[Count].ALinesPoints[LinePointCount];
        BlockWrite(ShapeFileOut, XTemp, 8); {X}
        inc(LinePointCount);
        YTemp :=
             AreaRecord[Count].ALinesPoints[LinePointCount];
        BlockWrite(ShapeFileOut, YTemp, 8); {Y}
        inc(LinePointCount);
      end; {IShape}
{}
      dbTable.Append;
      if ((bDLGSym) or (bDLGAtt) or (bDLGXaa)) then
      begin
        if (bDLGSym) then  {Statsgo}
        begin
           {Put in the DLG (Minor) and Sym soil attributes}
          InString := AreaRecord[Count].AAttributes;
          temp2 := Copy(InString, 1, 6);
          temp := trim(temp2);
          Val(temp, ShapeAttributeN2, ErrorCodex);
          if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          {if (not (bDLGSingleCodeCB)) then
          begin }
            temp2 := Copy(InString, 7, 6);
            temp := trim(temp2);
            Val(temp, ShapeAttributeN3, ErrorCodex);
            if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          {end;}
          if (bDLGNumberItemsCB) then
                 dbTable.FieldValues['COUNTI'] := Count;
          dbTable.FieldValues['MINORI'] :=
                        ShapeAttributeN3;
          SymChar := Pos(' ',SymArray[ShapeAttributeN3]);
          temp2 := Copy(SymArray[ShapeAttributeN3], SymChar, 7);
          temp := trim(temp2);
               {There are x(few) number for Many areas}
          dbTable.FieldValues['MUIDS'] := temp;

{          DLGMemo.Lines.Add(IntTostr(PointCount)+' = '
                           + IntTostr(Count)
                           +' MINORI ' + Inttostr(ShapeAttributeN3)
                           + ' MUIDS ' + temp);}

          if (bAddMapAttributesCB) then
          begin
            dbTable.FieldValues['MAPI'] := 0; ;
            dbTable.FieldValues['MAPF'] := 00.00;
          end;

        end else if (bDLGAtt) then
        begin
          if (bDLGNumberItemsCB) then
              dbTable.FieldValues['COUNTI'] := Count;
          {read all the attributes per count... 1 line per area record}
          Readln(AttSymFile, Instring);
            {SymChar := Pos(' ',Instring);
                temp2:=Copy(Instring,SymChar,7);
                temp:= trim(temp2);
                val(temp,II,ErrorCode);
                dbTable.FieldValues['MINOR'] := II; }
          SymChar := Pos(' ', Instring);
          temp2 := Copy(Instring, SymChar,Length(Instring));
          temp := trim(temp2);
             { temp:=Uppercase(DLGOpenDialog.filename[4]);}
          if temp2NRI = 'L' then
                        dbTable.FieldValues['MLRAS'] := temp
          else if temp2NRI = 'U' then
                        dbTable.FieldValues['HYDROS'] := temp
          else if temp2NRI = 'I' then
                        dbTable.FieldValues['FIPSS'] := temp
          else if temp2NRI = 'E' then
                        dbTable.FieldValues['MLRAS'] := temp;
          if (bAddMapAttributesCB) then
          begin
            dbTable.FieldValues['MAPI'] := 0; ;
            dbTable.FieldValues['MAPF'] := 00.00;
          end;

        end else if (bDLGXaa) then
        begin
          if (bDLGNumberItemsCB) then
                 dbTable.FieldValues['COUNTI'] := Count;
          IChar := Pos(#9, AttSymstring);
          temp2 := Copy(AttSymstring, IChar,length(AttSymstring));
          if (temp2[1] = #9) then temp2[1] := ' ';
          temp := trim(temp2); {Skip counter}
          IChar := Pos(#9, temp);
          temp2 := Copy(temp, IChar, length(temp));
          if (temp2[1] = #9) then
                  temp2[1] := ' ';
          temp := trim(temp2); {Skip Major}
          temp2 := temp; {put it nowhere till later}
          IChar := Pos(#9, temp);
          InString := Copy(temp, 1, IChar);
          temp := trim(InString);
          if (length(temp) = 0) then temp := '0';
          val(temp, II, ErrorCode);
          {put Minor in db}
          dbTable.FieldValues['MINORI'] := II;
          temp2 := Copy(temp2, IChar, length(temp2));
          if (temp2[1] = #9) then temp2[1] := ' ';
          temp := trim(temp2);
          {Skip3} temp2 := temp;
          IChar := Pos(#10, temp);
          if (IChar = 0) then IChar := length(temp);
          InString := Copy(temp, 1, IChar);
          temp := trim(InString);
          if (length(temp) = 0) then temp := '0';
          {put MUID in db }
          dbTable.FieldValues['MUIDS'] := temp;

{          DLGMemo.Lines.Add(IntTostr(PointCount)+' = '
                           + IntTostr(Count)
                           +' MINORI ' + Inttostr(II)
                           + ' MUIDS ' + temp);}

          temp2 := Copy(temp2, IChar, length(temp2));
          if (temp2[1] = #10) then temp2[1] := ' ';
          temp := trim(temp2);
          AttSymstring := temp; {put back for next loop}
          if (bAddMapAttributesCB) then
          begin
            dbTable.FieldValues['MAPI'] := 0; ;
            dbTable.FieldValues['MAPF'] := 00.00;
          end;
        end;
      end else
       {NO ATTRIBUTES so NO extras to Link either}
      if (MasterMaxShapeAttributeN = 0) then
      begin
        {dbTable.Append;}
        dbTable.FieldValues['COUNT'] := Count;
      {  dbTable.Post;}
      end else
      {WHAT is this ?}
      begin
        InString := AreaRecord[Count].AAttributes;
        for Incrementer := 0 to AreaRecord[Count].AttributeN - 1 do
        begin
          temp2 := Copy(InString, (1 + ((Incrementer) * 12)), 6);
          temp := trim(temp2);
          Val(temp, ShapeAttributeN2, ErrorCodex);
          if (ErrorCodex > 0) then
                     Codefx(temp, ErrorCodex);
          if (not (bDLGSingleCodeCB)) then
          begin
            temp2 := Copy(InString, (1 + ((Incrementer) * 12) + 6), 6);
            temp := trim(temp2);
            Val(temp, ShapeAttributeN3, ErrorCodex);
            if (ErrorCodex > 0) then Codefx(temp, ErrorCodex);
          end;
          if bDLGSingleCodeCB then
          begin {Only One code}
            if (bDLGNumberItemsCB) then
              dbTable.FieldValues['COUNT'] := Count;
            {str(I, tempstr); }
            dbTable.FieldValues['MINOR'] :=
                         ShapeAttributeN2;
            if (bAddMapAttributesCB) then
            begin
              dbTable.FieldValues['MAPI'] := 0; ;
              dbTable.FieldValues['MAPF'] := 00.00;
            end;
          end else
          if bDLGMinorCodesCB then
          begin {only Minors}
            if (bDLGNumberItemsCB) then
              dbTable.FieldValues['COUNT'] := Count;
            str(Incrementer, tempstr);
            dbTable.FieldValues['MINOR' + tempStr] :=
                         ShapeAttributeN3;
            if (bAddMapAttributesCB) then
            begin
              dbTable.FieldValues['MAPI'] := 0; ;
              dbTable.FieldValues['MAPF'] := 00.00;
            end;
          end else
          If bNothingChecked then
          begin {Major and Minor}
            if (bDLGNumberItemsCB) then
              dbTable.FieldValues['COUNT'] := Count;
            dbTable.FieldValues['MAJOR' ] :=
                       ShapeAttributeN2;
            dbTable.FieldValues['MINOR' ] :=
                       ShapeAttributeN3;
            if (bAddMapAttributesCB) then
            begin
              dbTable.FieldValues['MAPI'] := 0; ;
              dbTable.FieldValues['MAPF'] := 00.00;
            end;
            {Put in the Att or Sym}
          end; {DLG Minor codes}
        end; {I=0}

      end  { else showmessage('Nothing done')}      ; {Data types}

      inc(PointCountTotal);
    end; {Count=0}
        dbTable.Post;
  end; {Areas > 0}
  str(PointCountTotal-1, temp);
  THints.Caption := 'Areas correctly Processed ' + temp;
  DIAreaOut.Text := temp;

end; {Shapetype = 5}

      {---------------------------------------------------------------------}
      {End of Write the areas to a shape file}

      {Close up Shop}
      {---------------------------------------------------------------------}
      str(MaxShapeIslandsCount , temp);
      MaxShapeIslandsEdit.Text := temp;
      str(MaxShapeAttributeN, temp);
      MaxShapeAttEdit.Text := temp;
      str(TotalPointsAdded, temp);
      TotalPointsaddedEdit.Text := temp;
      str(TotalLinePointsAdded, temp);
      TotalLinePointsaddedEdit.Text := temp;
     {DELETE the database!!! REDUCE the MyDBCount or ELSE!!!}
      if ( dbTable.Exists) then
      begin
      dbTable.Active := False;
{      Session.DropConnections;
      Session.Active := False;
      MyDBCount := 0;}
      dec(MyDbCount); { Initialize MyDbCount early on }
      end;
      {COPY the database to allow Mapping values FileName, DestName}
      If FileExists(ChangeFileExt( ShapeNameEdit.Text, '.dbf')) then
      begin
      DuplicatorS :=
        ChangeFileExt( ShapeNameEdit.Text, '.dbf');
      DuplicatorS2:=copy(DuplicatorS,1,(length(DuplicatorS)-4));
       DuplicatorS2:=DuplicatorS2+'_'+'.dbf';
      CopyFile(PChar(ShapePath +DuplicatorS),
               PChar(ShapePath +DuplicatorS2), False);
      end;

      Finally

      CloseFile(IndexFileOut);
      CloseFile(ShapeFileOut);
      if (DLGhasLinefeeds) then CloseFile(F1) else
          CloseFile(DLGBlockIn);
      SetLength(LineRecord, 0);
          {interior arrays? SetLength(LineRecord.?,0);}
      SetLength(AreaRecord, 0);
          {interior arrays? SetLength(AreaRecord.?,0);}

      if bDLGAtt then begin CloseFile(AttSymFile); end;
      if bDLGXaa then begin AttSymstring:=''; end;
      if bDLGSym then begin SetLength(SymArray, 0); end;
      DLGGauge.Position := 0;
      THints.Caption := 'Shape Exporter Finished';
      end;{Finally}
    end else DoRezError(6);
  end else DoRezError(7);
  DLGhasLinefeeds := False;
end; {DLG Export procedure}
(*****************************************************************)
{
A    1   324272.14  1446203.88     0   312     0     1     0     0}

(******************************************************************)


(*******************************************************************)
(*******************************************************************)



(******************************************************************)
(******************************************************************)


(******************************************************************)

(******************************************************************)
procedure TTransformer.ShapeFileTypeRG(Which: Integer);
begin
  case Which of {Shapetype}
    1: ShapeViewerRG.ItemIndex := 0;{'Points';}
    3: ShapeViewerRG.ItemIndex := 1;{'Lines';}
    5: ShapeViewerRG.ItemIndex := 2;{'Areas';}
    8: ShapeViewerRG.ItemIndex := 3;{'MultiPnt';}
   11: ShapeViewerRG.ItemIndex := 4;{'PointsZ';}
   13: ShapeViewerRG.ItemIndex := 5;{'LinesZ';}
   15: ShapeViewerRG.ItemIndex := 6;{'AreasZ';}
   18: ShapeViewerRG.ItemIndex := 7;{'MultiPntZ';}
    21: ShapeViewerRG.ItemIndex := 8;{'PointsM';}
    23: ShapeViewerRG.ItemIndex := 9;{'LinesM';}
    25: ShapeViewerRG.ItemIndex := 10;{'AreasM';}
    28: ShapeViewerRG.ItemIndex := 11;{'MultiPntM';}
    31: ShapeViewerRG.ItemIndex := 12;{'Multi Patch';}
    32: ShapeViewerRG.ItemIndex := 12;{'Mesh TIN';}
    34: ShapeViewerRG.ItemIndex := 12;{'Multi Fan';}
    36: ShapeViewerRG.ItemIndex := 13;{'Multi Strip';}
    37: ShapeViewerRG.ItemIndex := 14;{'Multi OI Polys';}
    39: ShapeViewerRG.ItemIndex := 15;{'Multi Rings';}
  end; {of case}
end;

procedure TTransformer.ShapeViewOpenClick(Sender: TObject);
var
  bDTFB: Boolean;      BufByte:Byte;
  ShapeFileIn: file;
  TextDump: TextFile;
  Bitmap: TBitmap;
  InString2, temp2, temp, InString:  string;
  FileSizeCheck,
  BufI, I, ShapeType, NumPoints, NumParts, ByteArray, iV, iiV,
  FileSize, FileSizeNow, PointCount, IslandCount, AreaCount: integer;
    dXMIN,dYMIN,dXMAX,dYMAX,
  XShift, YShift, Ratio, xdiff, ydiff, XTemp, YTemp: Double;
  function SwapShapeInteger: Integer;
  var aByteArray, oByteArray: array[0..3] of Byte;
    Outgoing: Integer;
  begin
    Move(ByteArray, aByteArray, 4);
    oByteArray[0] := aByteArray[3];
    oByteArray[1] := aByteArray[2];
    oByteArray[2] := aByteArray[1];
    oByteArray[3] := aByteArray[0];
    Move(oByteArray, Outgoing, 4);
    Result := Outgoing;
  end;

begin
  DLGOpenDialog.InitialDir := ShapePath;
  DLGOpenDialog.Filter := 'Shape File (*.shp,*.shx)|*.shp;*.shx';
    temp := (DLGOpenDialog.filename);
    DLGOpenDialog.Filename:=ShapeViewEditFileName.Text+'.shp';
  if DLGOpenDialog.execute then begin
    THints.Caption := 'Shape Display Display';
    temp := ExtractFileName(DLGOpenDialog.filename);
    ShapeViewEditFileName.Text := temp;
    temp := ExtractFileExt(DLGOpenDialog.filename);
    if (uppercase(temp) = '.SHP') then begin
      ShapePath := ExtractFilePath(DLGOpenDialog.Filename);
      bDTFB := DatatoTextFileBox.Checked;
      AssignFile(ShapeFileIn, DLGOpenDialog.Filename);
      Reset(ShapeFileIn, 1); { Record size = 1 }
      if bDTFB then
      begin
        temp := ExtractFileName(DLGOpenDialog.filename);
        temp[length(temp) - 3] := '-';
        TempName := ShapePath + temp + '.txt';
      end;
      if bDTFB then AssignFile(TextDump, TempName);
      if bDTFB then Rewrite(TextDump);

      ShapeViewMemo.Clear;
        {Clear the memo before each selected file...after last}
      Bitmap := TBitmap.Create;
      Bitmap.Width := 313;
      Bitmap.Height := 313;
      ShapeViewImage.Picture.Graphic := Bitmap;
      ShapeViewImage.Canvas.Pen.Width := 1;
      ShapeViewImage.Canvas.Pen.Color := ClBlack;
      ShapeViewImage.Canvas.Pen.Style := psSolid;

      Application.ProcessMessages;
      {Bitmap.Free;  Freed at end...}
      FileSizeNow := 0;
      PointCount := 0;
      IslandCount := 0;
      AreaCount := 0;
      {Check Header }
{Set up Shape}
      BlockRead(ShapeFileIn, ByteArray, 4); {9994 file code}
      str(SwapShapeInteger, InString);
      if bDTFB then Writeln(TextDump, '9994 file code: ' + InString);
      ShapeViewMemo.Lines.Add('9994 file code: ' + InString);
      for I := 1 to 5 do begin {5 blank zeros}
        BlockRead(ShapeFileIn, ByteArray, 4);
        str(SwapShapeInteger, InString);
        ShapeViewMemo.Lines.Add('zero: ' + InString);
        if bDTFB then Writeln(TextDump, 'zero: ' + InString);
      end;

      BlockRead(ShapeFileIn, ByteArray, 4); {File size}
      FileSize := SwapShapeInteger;
      str(FileSize, InString);
      str((FileSize * 2), temp); {+' = 68428 ?'}
      ShapeViewMemo.Lines.Add('File size: ' + InString + '  Bytes: '
        + temp);
      if bDTFB then
        Writeln(TextDump, 'File size: ' + InString + '  Bytes: ' +
        temp);
      BlockRead(ShapeFileIn, BufI, 4);{Version 1000}
      str(BufI, InString);
      ShapeViewMemo.Lines.Add('Version 1000: ' + InString);
      if bDTFB then Writeln(TextDump, 'Version 1000: ' + InString);
      BlockRead(ShapeFileIn, BufI, 4); {Shapetype}
      str(BufI, InString);
      ShapeViewMemo.Lines.Add('Shapetype: ' + InString);
      if bDTFB then Writeln(TextDump, 'Shapetype: ' + InString);
      ShapeType := BufI;
      ShapeFileTypeRG(ShapeType);
{XMIN,YMIN,XMAX,YMAX:Double;}
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
       ShapeViewMemo.Lines.Add('XMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'XMIN: ' + InString);
      BlockRead(ShapeFileIn, dYMIN, 8);
      str(dYMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('YMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'YMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('XMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'XMAX: ' + InString);
      BlockRead(ShapeFileIn, dYMAX, 8);
      str(dYMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('YMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'YMAX: ' + InString);
{Set up the image Min max size ratio}
{Set screen area}
      xdiff := abs(dXMAX - dXMIN);
      ydiff := Abs(dYMAX - dYMIN);
      if (xdiff > ydiff) then Ratio := (xdiff / 312) else
        Ratio := (ydiff / 312);
      if dXMIN < 0 then begin XShift := abs(dXMIN) end
      else if dXMIN > 0 then XShift := (0 - dXMIN) else XShift := 0;
      if dYMIN < 0 then begin YShift := abs(dYMIN) end
      else if dYMIN > 0 then YShift := (0 - dYMIN) else YShift := 0;

      {Byte 68..100} {WAS 8 blank zeros... Now Z and M Min Max 's}
      {for I := 1 to 8 do begin
        BlockRead(ShapeFileIn, ByteArray, 4);
        str(SwapShapeInteger, InString);
        ShapeViewMemo.Lines.Add('zero: ' + InString);
        if bDTFB then Writeln(TextDump, 'zero: ' + InString);
      end;}
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('ZMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'ZMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('ZMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'ZMAX: ' + InString);
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('MMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'MMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('MMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'MMAX: ' + InString);

      FileSizeNow := FileSizeNow + 50;
      case ShapeType of
        1: {Point}
          begin
            while (not (eof(ShapeFileIn))) do
            begin
              Application.ProcessMessages;
              inc(AreaCount);
              FileSizeNow := FileSizeNow + 4;
              BlockRead(ShapeFileIn, ByteArray, 4); {Record Number}
              str(SwapShapeInteger, InString);
              if bDTFB then
                Writeln(TextDump, 'Record Number: ' + InString);
              {ShapeViewMemo.Lines.Add('Record Number: '+InString);}
              BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
              FileSizeCheck:=SwapShapeInteger;
              FileSizeNow := FileSizeNow + FileSizeCheck;
              str(SwapShapeInteger, InString);
              if bDTFB then
                Writeln(TextDump, 'Content length: ' + InString);
              {ShapeViewMemo.Lines.Add('Content length: '+InString);}

              BlockRead(ShapeFileIn, BufI, 4); {Shapetype}
              str(BufI, InString);
              if bDTFB then
                Writeln(TextDump, 'Shapetype: ' + InString);
                BlockRead(ShapeFileIn, XTemp, 8);
                BlockRead(ShapeFileIn, YTemp, 8);
                str(XTemp: 24: 12, InString);
                if bDTFB then
                  Writeln(TextDump, 'X Point: ' + InString);
                str(YTemp: 24: 12, InString);
                if bDTFB then
                  Writeln(TextDump, 'Y Point: ' + InString);
                XTemp := XTemp + XShift;
                YTemp := YTemp + YShift;
                iV := trunc((XTemp / Ratio));
                iiV := trunc((YTemp /Ratio));
                ShapeViewImage.Canvas.MoveTo(iV-2, 312 - (iiV-2));
                ShapeViewImage.Canvas.LineTo(iV+2, 312 - (iiV-2));
                ShapeViewImage.Canvas.LineTo(iV+2, 312 - (iiV+2));
                ShapeViewImage.Canvas.LineTo(iV-2, 312 - (iiV+2));
                ShapeViewImage.Canvas.LineTo(iV-2, 312 - (iiV-2));
If FileSizeCheck > 10 then
begin
FileSizeCheck:=(FileSizeCheck * 2);
for I:= 1 to FileSizeCheck-20 do
begin
              BlockRead(ShapeFileIn, BufByte,1);
              str(BufByte, InString);
              if bDTFB then
                Writeln(TextDump, 'too big: ' + InString);
end;
end;
            end;
            end;
        {Lines}
        3..5: {Polygon}
          begin
            while (not (eof(ShapeFileIn))) do begin
              Application.ProcessMessages;
              inc(AreaCount);
              FileSizeNow := FileSizeNow + 4;
              BlockRead(ShapeFileIn, ByteArray, 4); {Record Number}
              str(SwapShapeInteger, InString);
              if bDTFB then
                Writeln(TextDump, 'Record Number: ' + InString);
              {ShapeViewMemo.Lines.Add('Record Number: '+InString);}
              BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
              FileSizeNow := FileSizeNow + SwapShapeInteger;
              str(SwapShapeInteger, InString);
              if bDTFB then
                Writeln(TextDump, 'Content length: ' + InString);
              {ShapeViewMemo.Lines.Add('Content length: '+InString);}

              BlockRead(ShapeFileIn, BufI, 4); {Shapetype}
              str(BufI, InString);
              if bDTFB then
                Writeln(TextDump, 'Shapetype: ' + InString);
              {ShapeViewMemo.Lines.Add('Shapetype: '+InString);}
              {XMIN,YMIN,XMAX,YMAX:Double;}
              BlockRead(ShapeFileIn, dXMIN, 8);
              str(dXMIN: 24: 12, InString);
              if bDTFB then Writeln(TextDump, 'XMIN: ' + InString);
              {ShapeViewMemo.Lines.Add('XMIN: '+InString);}
              BlockRead(ShapeFileIn, dYMIN, 8);
              str(dYMIN: 24: 12, InString);
              if bDTFB then Writeln(TextDump, 'YMIN: ' + InString);
              {ShapeViewMemo.Lines.Add('YMIN: '+InString);}
              BlockRead(ShapeFileIn, dXMAX, 8);
              str(dXMAX: 24: 12, InString);
              if bDTFB then Writeln(TextDump, 'XMAX: ' + InString);
              {ShapeViewMemo.Lines.Add('XMAX: '+InString);}
              BlockRead(ShapeFileIn, dYMAX, 8);
              str(dYMAX: 24: 12, InString);
              if bDTFB then Writeln(TextDump, 'YMAX: ' + InString);
              {ShapeViewMemo.Lines.Add('YMAX: '+InString);}


              BlockRead(ShapeFileIn, Numparts, 4); {Numparts}
              str(Numparts, InString);
              if bDTFB then
                Writeln(TextDump, 'Numparts: ' + InString);
                {ShapeViewMemo.Lines.Add('Numparts: '+InString);}
      {CHANGE the array size to Numparts}
              BlockRead(ShapeFileIn, NumPoints, 4); {NumPoints}
              str(NumPoints, InString);
              if bDTFB then
                Writeln(TextDump, 'NumPoints: ' + InString);
              {ShapeViewMemo.Lines.Add('NumPoints: '+InString);}
    {GET the Parts array data}
              for I := 1 to Numparts do begin {Always at least 1}
                inc(IslandCount);
                BlockRead(ShapeFileIn, BufI, 4); {Parts...}
                str(BufI, InString);
                str(AreaCount, temp);
                str(IslandCount, temp2);
                if bDTFB then
                  Writeln(TextDump, 'Area ' + temp + ' Part ' + temp +
                  ':' + InString);
{                ShapeViewMemo.Lines.Add('Area ' + temp + ' Part ' +
                  temp2 + ':' + InString);}
              end;
      {Get the Parts array and use to divide lines}
              for I := 1 to 1 do begin {2 points internally}
                inc(PointCount, 2);
                BlockRead(ShapeFileIn, XTemp, 8);
                BlockRead(ShapeFileIn, YTemp, 8);
                str(XTemp: 24: 12, InString);
                if bDTFB then
                  Writeln(TextDump, 'X Point: ' + InString);
                str(YTemp: 24: 12, InString);
                if bDTFB then
                  Writeln(TextDump, 'Y Point: ' + InString);
                XTemp := XTemp + XShift;
                YTemp := YTemp + YShift;
                iV := trunc((XTemp / Ratio));
                iiV := trunc((YTemp /Ratio));
                ShapeViewImage.Canvas.MoveTo(iV, 312 - iiV);
              end;
              for I := 2 to NumPoints do begin {2 points internally}
                inc(PointCount, 2);
                BlockRead(ShapeFileIn, XTemp, 8); {POINTS....}
                str(XTemp: 24: 12, InString);
                str(I, temp);
                if bDTFB then
                  Writeln(TextDump, 'X Point ' + temp + ':' +
                  InString);
              {ShapeViewMemo.Lines.Add('X Point: '+InString);}
                BlockRead(ShapeFileIn, YTemp, 8);
                str(YTemp: 24: 12, InString);
                if bDTFB then
                  Writeln(TextDump, 'Y Point: ' + InString);
              {ShapeViewMemo.Lines.Add('Y Point: '+InString);}
              {PLOT THE XandY POINTS}
                XTemp := XTemp + XShift;
                YTemp := YTemp + YShift;
                iV := trunc((XTemp / Ratio));
                iiV := trunc((YTemp /Ratio));
                ShapeViewImage.Canvas.LineTo(iV, 312 - iiV);
              end;
            end; {For II}
          end; {shape type...Polygon}
        8:  DoRezError(13){Multi Point};
        11: DoRezError(13) {Point M};
        13: DoRezError(13){Lines M};
        15: DoRezError(13){Polygon M};
        18: DoRezError(13){Multi Point M};
        21: DoRezError(13){Point Z};
        23: DoRezError(13){Lines Z};
        25: DoRezError(13){Polygon Z};
        28: DoRezError(13){Multi Point Z};
        31: DoRezError(13){Point Patch};
      end; {Case}

{File Size and File size read}
      str(FileSize, InString);
      ShapeViewEditFile.Text := InString;
      str(FileSizeNow, InString);
      ShapeViewEditFileDone.Text := InString;
{30812 -30628= 184 words= 368 bytes..missing?}
      str(PointCount, InString);
      ShapeViewEditPtP.Text := InString;
      str(IslandCount, InString);
      ShapeViewEditArP.Text := InString;
      str(AreaCount, InString);
      ShapeViewEditLnP.Text := InString;
      Bitmap.Free;
      CloseFile(ShapeFileIn);
      if bDTFB then CloseFile(TextDump);
    end {If SHP}

    else  if (uppercase(temp) = '.SHX') then
    begin
      {read the index file... but not data?}
      bDTFB := DatatoTextFileBox.Checked;
      AssignFile(ShapeFileIn, DLGOpenDialog.Filename);
      Reset(ShapeFileIn, 1); { Record size = 1 }
      if bDTFB then
      begin
        temp := ExtractFileName(DLGOpenDialog.filename);
        temp[length(temp) - 3] := '-';
        TempName := ShapePath + temp + '.txt';
      end;
      if bDTFB then AssignFile(TextDump, TempName);
      if bDTFB then Rewrite(TextDump);

      ShapeViewMemo.Clear;
        {Clear the memo before each selected file...after last}
      Application.ProcessMessages;
      FileSizeNow := 0;
      PointCount := 0;
      IslandCount := 0;
      AreaCount := 0;
{Check Header }
{   MaxShapeAttributeN:=0;
   ShapeAttributeN:=0;}
{Set up Shape}
      BlockRead(ShapeFileIn, ByteArray, 4); {9994 file code}
      str(SwapShapeInteger, InString);
      if bDTFB then Writeln(TextDump, '9994 file code: ' + InString);
      ShapeViewMemo.Lines.Add('9994 file code: ' + InString);
      for I := 1 to 5 do begin {5 blank zeros}
        BlockRead(ShapeFileIn, ByteArray, 4);
        str(SwapShapeInteger, InString);
        ShapeViewMemo.Lines.Add('zero: ' + InString);
        if bDTFB then Writeln(TextDump, 'zero: ' + InString);
      end;

      BlockRead(ShapeFileIn, ByteArray, 4); {File size}
      FileSize := SwapShapeInteger; str(FileSize, InString);
      str((FileSize * 2), temp); {+' = 68428 ?'}
      ShapeViewMemo.Lines.Add('File size: ' + InString + '  Bytes: '
        + temp);
      if bDTFB then
        Writeln(TextDump, 'File size: ' + InString + '  Bytes: ' +
        temp);
      BlockRead(ShapeFileIn, BufI, 4);
      str(BufI, InString);
      ShapeViewMemo.Lines.Add('Version 1000: ' + InString);
        {Version 1000}
      if bDTFB then Writeln(TextDump, 'Version 1000: ' + InString);
      BlockRead(ShapeFileIn, BufI, 4);
      str(BufI, InString);
      ShapeViewMemo.Lines.Add('Shapetype: ' + InString); {Shapetype}
      if bDTFB then Writeln(TextDump, 'Shapetype: ' + InString);
      ShapeType := BufI;
      ShapeFileTypeRG(ShapeType);
{XMIN,YMIN,XMAX,YMAX:Double;}
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
       ShapeViewMemo.Lines.Add('XMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'XMIN: ' + InString);
      BlockRead(ShapeFileIn, dYMIN, 8);
      str(dYMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('YMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'YMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('XMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'XMAX: ' + InString);
      BlockRead(ShapeFileIn, dYMAX, 8);
      str(dYMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('YMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'YMAX: ' + InString);

      {Byte 68..100} {Z and M Min and Max}
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('ZMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'ZMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('ZMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'ZMAX: ' + InString);
      BlockRead(ShapeFileIn, dXMIN, 8);
      str(dXMIN: 24: 12, InString);
      ShapeViewMemo.Lines.Add('MMIN: '  + InString);
      if bDTFB then Writeln(TextDump, 'MMIN: ' + InString);
      BlockRead(ShapeFileIn, dXMAX, 8);
      str(dXMAX: 24: 12, InString);
      ShapeViewMemo.Lines.Add('MMAX: ' + InString);
      if bDTFB then Writeln(TextDump, 'MMAX: ' + InString);
      FileSizeNow := FileSizeNow + 50;
            while (not (eof(ShapeFileIn))) do
            begin
              Application.ProcessMessages;
              inc(AreaCount);
              FileSizeNow := FileSizeNow + 4;
              BlockRead(ShapeFileIn, ByteArray, 4); {Offset}
              str(SwapShapeInteger, InString);
              BlockRead(ShapeFileIn, ByteArray, 4); {Content length}
              str(SwapShapeInteger, InString2);
              if bDTFB then
                Writeln(TextDump,'Offset: ' + InString
                          + ' Content length: ' + InString2);
{              ShapeViewMemo.Lines.Add('Offset: '+InString
                          +' Content length: '+InString2);}
              end;
{File Size and File size read}
      str(FileSize, InString);
      ShapeViewEditFile.Text := InString;
      str(FileSizeNow, InString);
      ShapeViewEditFileDone.Text := InString;
{30812 -30628= 184 words= 368 bytes..missing?}
      str(PointCount, InString);
      ShapeViewEditPtP.Text := InString;
      str(IslandCount, InString);
      ShapeViewEditArP.Text := InString;
      str(AreaCount, InString);
      ShapeViewEditLnP.Text := InString;
      CloseFile(ShapeFileIn);
      if bDTFB then CloseFile(TextDump);
    end;
  end {IF OPENED}
    else DLGOpenDialog.filename:=temp;
end; {PROCEDURE}
(******************************************************************)
(******************************************************************)


(******************************************************************)
(******************************************************************)

(********************************************************************)


(******************************************************************)
(*****************************************************************)
{        XMax :=  5.0  * power(10,-324);
        YMax :=  5.0  * power(10,-324);
        XMin :=  1.7 * power(10,308);
        YMin := 1.7 * power(10,308);}

(******************************************************************)
(*
      If (ShapeLinePointsN=0) then begin
      str(AreaCount+1,temp2);
      DLGMemo.Lines.Add(ShapeString);
{      MessageDlg('Area '+temp2+' : '+ShapeString,mtInformation,[mbOk], 0);}
      {Each island has a Zero record before it
      else store as a line number and get the points later}
        If (ShapeIslandsN=0)then begin {Just checking cause it got weird}
                MessageDlg('dead Island at '+temp2+' : '+temp,
                 mtInformation,[mbOk], 0);
                 exit;
                 {Exits from this whole procedure...
                  something really wrong}
                 end else begin
        inc(IslandCounter);
        AreaRecord[AreaCount].IslandsArray[0]:=0;
        AreaRecord[AreaCount].IslandsArray[1]:=0;
        AreaRecord[AreaCount].IslandsArray[(IslandCounter*2)]
                                        :=IslandCounter;
        {Which point it is AT... will be located in Line reading}
        AreaRecord[AreaCount].IslandsArray[((IslandCounter*2)+1)]
                               :=IslandCounter2{ShapeLinePointsN};
        end; {Islands}
      end else begin
                AreaRecord[AreaCount].ALines[IslandCounter2{IIAreaCount}]
                                          :=ShapeLinePointsN;
                inc(IslandCounter2);
               end;
*)
(*
           temp:=Copy(InString,1,12);temp:=trim(temp);
           Val(temp,XTemp,ErrorCodex);
           temp2:=Copy(InString,13,12);temp2:=trim(temp2);
           Val(temp2,YTemp,ErrorCodey);
{7}        IF ((ErrorCodex=0) and (ErrorCodey=0)) then begin
                LineRecord[Count].LinesPoints[LinePointCount]:=XTemp;
                inc(LinePointCount);
                LineRecord[Count].LinesPoints[LinePointCount]:=YTemp;
                inc(LinePointCount);
{6}        end else MessageDlg('Bad X '+temp+ ' Y '+temp2,
                        mtInformation,[mbOk], 0);
*)
(*
{6}        If (NumberLines < 1) then begin
        {Just make a start if it is a short line}
                temp:=Copy(InString,1,12);temp:=trim(temp);
                Val(temp,XTemp,ErrorCodex);
                temp2:=Copy(InString,13,12);temp2:=trim(temp2);
                Val(temp2,YTemp,ErrorCodey);
{7}             IF ((ErrorCodex=0) and (ErrorCodey=0)) then begin
                LineRecord[Count].LinesPoints[LinePointCount]:=XTemp;
                inc(LinePointCount);
                LineRecord[Count].LinesPoints[LinePointCount]:=YTemp;
                inc(LinePointCount);
{6}             end;
{5}        end;
*)
(******************************************************************)
(******************************************************************)


(******************************************************************)
(******************************************************************)

procedure TTransformer.NRINatsgoPointsBtnClick(Sender: TObject);
begin
(*  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'Natsgo Point data (*.TAB)|*.*';
  DLGOpenDialog.InitialDir := VRMDatabase;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then begin
    NRINatsgoPointsStr := DLGOpenDialog.Filename;
    NatsgoPdataEdit.Text := ExtractFileName(NRINatsgoPointsStr);
    VRMDatabase := ExtractFilePath(NRINatsgoPointsStr);
  end; *)
end;

procedure TTransformer.NRINatsgoPointsBtnShapeClick(Sender: TObject);
begin
(*  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'Natsgo Shape file|*.SHP';
  DLGOpenDialog.InitialDir := ShapePath;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then begin
    NRINatsgoPShapeStr := DLGOpenDialog.Filename;
    NatsgoPShapeEdit.Text := ExtractFileName(NRINatsgoPShapeStr);
    ShapePath := ExtractFilePath(NRINatsgoPShapeStr);
  end;*)
end;

procedure TTransformer.NRINatsgoPointsBtnGOClick(Sender: TObject);
begin {NRI: Natsgo Points}
(*  TransoilPointdb;*)
end;

procedure TTransformer.NRIDataBtnClick(Sender: TObject);
begin
(*  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'Natsgo Soil data tables|*.*';
  DLGOpenDialog.InitialDir := VRMDatabase;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then begin
    NRINatsgoTablesStr := DLGOpenDialog.Filename;
    NatsgodataEdit.Text := ExtractFileName(NRINatsgoTablesStr);
    VRMDatabase := ExtractFilePath(NRINatsgoTablesStr);
  end;*)
end;

procedure TTransformer.NRIShapeBtnClick(Sender: TObject);
begin
(*  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'Natsgo Shape file|*.SHP';
  DLGOpenDialog.InitialDir := ShapePath;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then begin
    NRINatsgoTShapeStr := DLGOpenDialog.Filename;
    NatsgoShapeEdit.Text := ExtractFileName(NRINatsgoTShapeStr);
    ShapePath := ExtractFilePath(NRINatsgoTShapeStr);
  end;*)
end;

procedure TTransformer.NRIGOBtnClick(Sender: TObject);
begin
(*  TranPointdodb;*)
end;
(******************************************************************)

(******************************************************************)
procedure TTransformer.StateStatsgoBtnClick(Sender: TObject);
begin
  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter :=
  'Statsgo(sym),Ssurgo (#af,#sf)|*.*;*.sym;*.?af;*.?sf';
  DLGOpenDialog.InitialDir := VRMDatabase;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then begin
    StateStatsgoStr := DLGOpenDialog.Filename;
    StatsgoEdit.Text := ExtractFileName(StateStatsgoStr);
    VRMDatabase := ExtractFilePath(StateStatsgoStr);
  end;
end;

procedure TTransformer.StateStatsgoBtnShapeClick(Sender: TObject);
begin
  {NRINatsgoPointsStr,NRINatsgoPShapeStr,
NRINatsgoTablesStr,NRINatsgoTShapeStr,
StateStatsgoStr,StateStatsgoShapeStr,
CountySurgoStr,CountySurgoShapeStr:String;}
  {Open files to select a DLG data file - to - image}
  DLGOpenDialog.Filter := 'Statsgo,Surgo Shape file(*.shp)|*.shp;*.*';
  DLGOpenDialog.InitialDir := ShapePath;
    DLGOpenDialog.Filename:='';
  if DLGOpenDialog.execute then
  begin
    StateStatsgoShapeStr := DLGOpenDialog.Filename;
    StatsgoShapeEdit.Text := ExtractFileName(StateStatsgoShapeStr);
    ShapePath := ExtractFilePath(StateStatsgoShapeStr);
  end;
end;

procedure TTransformer.StateStatsgoBtnGOClick(Sender: TObject);
begin
  Transoildodb;  {  unit Vtransoil;}
end;
(******************************************************************)
(******************************************************************)


(******************************************************************)
(******************************************************************)
procedure TTransformer.ImportImageLocationsBtnClick(Sender: TObject);
begin
{TongsImage DB}
end;

procedure TTransformer.ImportPersonsImageAddressBtnClick(Sender: TObject);
begin
{TongsPeople DB

Family Address..Images}
end;

procedure TTransformer.ImportObjectArealImageBtnClick(Sender: TObject);
begin
{Tree.itv into a DB.. Shape file}
end;

procedure TTransformer.ImportDataCoverageBtnClick(Sender: TObject);
begin
{DUNNO where the data comes from... Locatable ?}
end;
(******************************************************************)
(******************************************************************)


(******************************************************************)
(******************************************************************)


end.
