{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LOResMess;

interface

uses  SysUtils,Dialogs,LoGlobals;

procedure Codefx(WhatString: string; Codein: Integer);
procedure DoRezInfo(i: Integer);
function DoRezConfirm(i: Integer):Word;
function DoRezConfirmYAC(i,i2: Integer):Word;
procedure DoRezWarn(i: Integer);
procedure DoRezError(i: Integer);
//Function FileTyper(Input,Output:String): Integer;

implementation
      (*
Function FileTyper(Input,Output:String): Integer;
var
  NameI1, NameI2, NameI3, NameI4, NameI5, NameI6, NameI7, NameI,
    Totaler, Totaler3{, ColorCode}: Integer;
  NameS: string;
  cChar: Char;
Begin
  Result:=0;
  if (Input = Output) then
  begin
    Result:=-1;
  end else
  if (Length(Input) <> 20) then
  begin end//DoMessages(17)
  else
  begin
     Result:=1;
      NameS := Input;
      cChar := NameS[11];
      NameI1 := (ord(cChar) );
      cChar := NameS[12];
      NameI2 := (ord(cChar) );
      cChar := NameS[13];
      NameI3 := (ord(cChar));
      cChar := NameS[14];
      NameI4 := (ord(cChar));
      cChar := NameS[15];
      NameI5 := (ord(cChar) );
      cChar := NameS[20];
      NameI6 := (ord(cChar) );
      cChar := NameS[17];
      NameI7 := (ord(cChar) );
      Totaler := (NameI1) + (NameI4) + (NameI3)- (NameI7);
      NameI := (NameI5) + (NameI6) + (NameI2);

      cChar := NameS[18];
      NameI4 := (ord(cChar));
      cChar := NameS[19];
      NameI5 := (ord(cChar) );
      cChar := NameS[16];
      NameI6 := (ord(cChar) );
      Totaler3 := (((NameI4) + (NameI6)) - (NameI5));

      Totaler := Totaler + Totaler3;
      if (Totaler <> NameI) then
      begin end //DoMessages(16)
      else
      begin
        Result:=2;
      end;
  end;
End;  *)

procedure Codefx(WhatString: string; Codein: Integer);
{var CodeS:String;}
begin
  if Codein <> 0 then
  begin
    MessageDlgPos(
      'Error in File data Number: '
      + #13#10 + IntToStr(Codein)
      + #13#10 + WhatString,
      mtError,
      [mbOK],
      0,
      MessageX,
      MessageY);
  end;
end;

procedure DoRezInfo(i: Integer);
var   {mtInformation	 a blue "i".}
  s:array[0..79] of Char;
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of
    1: Messagestr := 'Resistance is futile';
    2:Messagestr := 'Edit Vector.shp files'
         + #13#10 + '    Voice Editor   ';
{    3:Messagestr := '.shp files already loaded'
         + #13#10 + 'Clear all'
         + #13#10 + 'or "Save As" a .map file';}
    4:Messagestr := 'Not a Number';
    5:Messagestr := 'Set Layer Label Properties first';
    6:Messagestr := 'This is the Space Bar.'
   +#13#10+ 'Phils not here nowhere'
   +#13#10+ 'Prince Elwood is canned'
   +#13#10+ 'All your base are mined';
    7:Messagestr := 'File Exists'+#13#10+'Input a different name';
    9: Messagestr := 'Under Construction: nothing happened';
    10: Messagestr := 'Image not loaded';
    11: Messagestr := 'Requires True Color (24 bit) Colors Setting';
    12: Messagestr := 'Requires TRUE COLOR (24 bit) Image';
    13: Messagestr := 'Improper Choices: nothing happened';
    14: Messagestr := 'I found one';
    15: Messagestr := 'Number input wrong,' + #13 + #10 +
      'Please try again';
    9999: Messagestr := 'Resistance is futile'
      + #13#10 + 'All Messages end here';
  end;
        if ((InfoBeepOn) and (not VoicesON)) then Beep;
        if ((InfoBeepOn) and (VoicesON)
          and (FileExists(ExtractFilePath(ParamStr(0))
                          + 'ERRORV.WAV')) )then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
          if (MMSysHandle <> 0) then  PlaySound(s,  0);
        end;
     MessageDlgPos(Messagestr, mtInformation, [mbOK], {mbYesNoCancel,}
        HelpContextl, MessageX, MessageY);
end;

function DoRezConfirm(i: Integer):Word;
var   { mtConfirmation	a green question mark.}
  s:array[0..79] of Char;
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of
    1: Messagestr := 'Do you wanna dance?';
    2:;
    3: Messagestr := 'Map Modified. Save changes?';
  end;
        if ((ConfirmBeepOn) and (not VoicesON)) then Beep;
        if ((ConfirmBeepOn) and (VoicesON)
          and (FileExists(ExtractFilePath(ParamStr(0))
                          + 'ERRORV.WAV')) )then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
          if (MMSysHandle <> 0) then  PlaySound(s,  0);
        end;
   Result:= MessageDlgPos(Messagestr,
        mtConfirmation, { mbYesNoCancel,} [mbYes,mbNo],
        HelpContextl, MessageX, MessageY);
{type TMsgDlgBtn =
(mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry,
mbIgnore, mbAll, mnNoToAll, mbYesToAll, mbHelp);
const
  mbYesNoCancel = [mbYes, mbNo, mbCancel];
  mbOKCancel = [mbOK, mbCancel];
  mbAbortRetryIgnore = [mbAbort, mbRetry, mbIgnore];
mrNone	mrAbort	mrYes
mrOk	mrRetry	mrNo
mrCancel	mrIgnore	mrAll}
end;


function DoRezConfirmYAC(i,i2: Integer):Word;
var   { mtConfirmation	a green question mark.}
  s:array[0..79] of Char;
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of
    1: Messagestr := 'Do you wanna dance?';
    2: Messagestr := 'Print 1 [OK] or [All] '+InttoStr(i2)+' pages?';
    3:Messagestr := 'Shape Layer'+InttoStr(i2)+ ' Modified. Save changes?';
  end;
        if ((ConfirmBeepOn) and (not VoicesON)) then Beep;
        if ((ConfirmBeepOn) and (VoicesON)
          and (FileExists(ExtractFilePath(ParamStr(0))
                          + 'ERRORV.WAV')) )then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
          if (MMSysHandle <> 0) then  PlaySound(s,  0);
        end;
   Result:= MessageDlgPos(Messagestr,
        mtConfirmation, { mbYesNoCancel,} [mbYes,mbAll,mbCancel],
        HelpContextl, MessageX, MessageY);
{type TMsgDlgBtn =
(mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry,
mbIgnore, mbAll, mnNoToAll, mbYesToAll, mbHelp);
const
  mbYesNoCancel = [mbYes, mbNo, mbCancel];
  mbOKCancel = [mbOK, mbCancel];
  mbAbortRetryIgnore = [mbAbort, mbRetry, mbIgnore];
mrNone	mrAbort	mrYes
mrOk	mrRetry	mrNo
mrCancel	mrIgnore	mrAll}
end;


procedure DoRezWarn(i: Integer);
var  {mtWarning   a yellow exclamation point symbol.}
  s:array[0..79] of Char;
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of
    1:;
    40: Messagestr := 'Converts 32 to 24 bit Color images';    
    20004: Messagestr := 'Not Registered!'
              +#13#10+   'Please register Voice';
    20006: Messagestr := 'Voice will fail without Registration'
               + #13#10 +'See About Register';
    else Messagestr := 'Resistance is futile';
  end;
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)
          and (FileExists(ExtractFilePath(ParamStr(0))
                          + 'ERRORV.WAV')) )then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
          if (MMSysHandle <> 0) then  PlaySound(s,  0);
        end;
   MessageDlgPos(Messagestr, mtWarning, [mbOK], {mbYesNoCancel,}
        HelpContextl, MessageX, MessageY);
end;

{          MessageDlgPos('Lines are maligned at ' + temp,
                  mtWarning, [mbOK], 0, MessageX, MessageY);
                  MessageDlgPos('X ' + temp + ' Y ' + temp2,
                  mtWarning, [mbOK], 0, MessageX, MessageY);

                  }

procedure DoRezError(i: Integer);  {ShowMessage  MessageDlg  MessageBox}
var  { mtError a red stop sign.}
  s:array[0..79] of Char;
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of
    2: Messagestr :='Cannot locate WINMM.DLL or MMSYSTEM.DLL.. no sounds';
    3: Messagestr :='File rename error';
    4: Messagestr :='No attribute file exists';
    5: Messagestr :='No attribute to Db files found ';
    6: Messagestr :='Export Filename.ext must be 8.3: Filename too long '
        + #13#10+   'Reduce-Change the Filename and Press OK again';
    7: Messagestr :='Select a DLG file to Import-> Shape Export';
    8: Messagestr :='Table not made';
    9: Messagestr :=    'X Error';
    10: Messagestr :=    'Y Error';
    11: Messagestr :=    'File MUST be a DLG file';
    12: Messagestr :='Please Select a DLG File';
    13: Messagestr :='I do not do MultiPatch...'
        + #13#10 +   'show me a MultiPatch';
    14: Messagestr :='Area Lines got Lost';
    15: Messagestr :='SoManyPoints overflow';
    16: Messagestr := 'Registration Number invalid';
    17: Messagestr := 'Not Registered!'
          +#13#10+   'Please register Voice';
    18: Messagestr :='I do not do Special Features...'
        + #13#10 +   'still working on Special Features';
    19: Messagestr :='file not loaded';
    20: Messagestr :='Database file not found';
    21: Messagestr := 'Points are NOT Soiled';
    22: Messagestr := 'Failed reading locatble.pof File';
    23: Messagestr := 'Failed writing locatble.pof File';
    24: Messagestr := 'locatble.pof Does NOT Exist';
{ DoRezError(21); }
    100: Messagestr :='Projection is not Geo';


    20001: Messagestr := 'Order.txt Files not found';
    20002: Messagestr := 'License.doc Files not found';
    20003: Messagestr := 'Readme.txt Files not found';
    30000: Messagestr := 'There is an Error in the system';
    30001: Messagestr := 'Voice failed without Registration'
                     + #13#10 +'See About Register';
    30002: Messagestr := 'File has BOTH CR AND LF... I quit';
    30003: Messagestr :=
    'Select an input .dlg file and a shape file deposit location';
    {MessageDlg('First locate ' +Transformer.StatsgoEdit.Text
    + #13#10+ ' and ' + Transformer.StatsgoShapeEdit.Text,
      mtError, [mbOk], 0);}
    30004: Messagestr := 'File has NO Cr or LF... I quit';
    30005: Messagestr := 'Voice failed without Registration';    
    39976: Messagestr := ' An error was detected when'
                +#13#10+ 'trying to fetch registration info.';
  end;                              { Beep(10000, 1000);}
        if ((ErrorBeepOn) and (not VoicesON)) then Beep;
        if ((ErrorBeepOn) and (VoicesON)
          and (FileExists(ExtractFilePath(ParamStr(0))
                          + 'ERRORV.WAV')) )then
        begin
          StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'ERRORV.WAV');
          if (MMSysHandle <> 0) then  PlaySound(s,  0);
        end;
   MessageDlgPos(Messagestr, mtError,[mbOK], {mbYesNoCancel,}
          HelpContextl, MessageX, MessageY);
end;



  (*
procedure DoMessages(i: Integer);
var
  Messagestr: string;
  HelpContextl: Longint;
begin
  HelpContextl := 0;
  case i of {Do_Messages(11}
{1..9999 mtInformation	A message box containing a blue "i".}

    2: Messagestr := 'the Voice program options file' + #13#10 +
      ExtractFilePath(ParamStr(0)) + 'voice.pof' + #13#10 +
        'Does NOT Exist:... Will Make it' {+ #13#10 +
        'Please set Options and Directories in' + #13#10 +
        'Investigate Menu: Options... '};




    18: Messagestr := 'Gotta have a Distance Value';
    19: Messagestr := 'Invalid Distance Values';
    20: Messagestr := 'Cannot Change unless Loaded';
    21: Messagestr := 'Only Rotate has more than 2 Stages';
    22: Messagestr := 'Only Sobel and Rotate have more than 1 Stage';
    23: Messagestr := 'Cannot Change unless Clear';
    24: Messagestr := 'Top Center Square value wrong';
    25: Messagestr := 'First Load an image to display';
    26: Messagestr := 'no font';
    27: Messagestr := 'The DIS name MUST be Different from DIH' +
      #13#10 +
        'else many .B?? will have the same name';
    28: Messagestr := '3. Gotta have a PNG File name';
    29: Messagestr := 'Band 1 File does not Exist!';
    30: Messagestr := '1. Header record needed';
    31: Messagestr := '2. Gotta have a Band 1 File name';
    32: Messagestr := '2. Gotta have a Band 2 File name';
    33: Messagestr := '2. Gotta have a Band 3 File name';
    34: Messagestr := 'Band 2 File does not Exist!';
    35: Messagestr := 'Band 3 File does not Exist!';
    36: Messagestr := 'Some size is wrong';
    37: Messagestr := 'Already Printing';
    38: Messagestr := 'Printing aborted';
    39: Messagestr := 'RGB Boolean set to Somethingthing!';
    40: Messagestr := 'Converts 32 to 24 bit Color images';
    41: Messagestr := '4bit to 24 bit bitmapped';
    42: Messagestr := '8bit to 24 bit bitmapped';
    43: Messagestr := '15bit to 24 bit bitmapped';
    44: Messagestr := '16bit to 24 bit bitmapped';
    45: Messagestr := '32bit to 24 bit bitmapped';
    46: Messagestr := 'There is no image currently loaded to save.';
{  Do_Messages(40 }


{10000..19999 mtConfirmation	A message box containing a green question mark.}

    10001: Messagestr :=
      'a DIH Header exists, use+append+overwrite instead?';
{20000..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
    20000: Messagestr := 'Danger Danger';


    20004: Messagestr := 'Grip will fail without Registration' +
      #13#10 +
        'Registration Warning' + #13#10 +
        'See Grip Register';
{Do_Messages( 20004}

{30000..40000 mtError  A message box containing a red stop sign.}

    30001: Messagestr := 'Grip failed without Registration' + #13#10
      +
        'Registration Error' + #13#10 +
        'See Grip Register';



{DoMessages( 30004);}
    39967: Messagestr :=
      'Header Crashed: Cancel or fix DIS Subset Width';
    39968: Messagestr := 'File unknown';
    39969: Messagestr := 'Not a Radar DAT file';
    39970: Messagestr :=
      'Header Crashed: Cancel or fix Number of Bands';
    39971: Messagestr := 'Header Crashed: Cancel or fix Coordinates';
    39972: Messagestr := 'NO HDR FILE NAME!?! ... Bad File Error';
    39973: Messagestr := 'Error - no files in the Zip file';
    39974: Messagestr := 'Disk full!?! ... Bad File Error';
    39975: Messagestr := 'Image Undone or crashed' +
      #13#10 + 'Restart Line Profile or exit';

    39977: Messagestr := 'You Crashed ! OUT of Resources!';
    39978: Messagestr := 'Image less than 1024x1024';
    39979: Messagestr := 'Image less than 512x512';
    39980: Messagestr := 'Image less than 256x256';
    39981: Messagestr := 'Stats Error.. Image buggered';
    39982: Messagestr := 'Filter File unknown';
    39983: Messagestr := 'Filename has reached 999';
    39984: Messagestr := 'Failed reading GRIP.pof File';
    39985: Messagestr := 'GRIP.pof Does NOT Exist';
    39986: Messagestr := 'Failed writing GRIP.pof File';
    39987: Messagestr := 'Stat error';
    39988: Messagestr := 'Height not equal to BR';
    39989: Messagestr := 'Width not equal to RC';
    39990: Messagestr :=
      'Horizontal height: 1and2, 3and4 must be same height'
        + #13#10 + 'Vertical width: 1and3, 2and4 must be same width';
    39991: Messagestr := 'Horizontal height not same = equal';
    39992: Messagestr := 'Vertical Width not same = equal';
    39993: Messagestr :=
      'Variables blank, files invalid, or page turned';
    39994: Messagestr := 'Not a DIH file';
    39995: Messagestr := 'Not a DISP file';
    39996: Messagestr := 'Not a DIP file';
    39997: Messagestr := 'NO HDR FILE NAME!?!';
    39998: Messagestr := 'Error opening file';
    39999: Messagestr := 'There is an Error in the system';
    40000: Messagestr := 'FATAL Error creating bitmap... byebye';
  end;

  case i of {2,147,483,648..2,147,483,647}
{mtInformation	A message box containing a blue "i".}
    1..9999: MessageDlgPos(Messagestr,
        mtInformation,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
{mtConfirmation	A message box containing a green question mark.}
    10000..19999: MessageDlgPos(Messagestr,
        mtConfirmation,
                {[mbOK],} mbYesNoCancel,
        HelpContextl,
        MessageX,
        MessageY);
{mtWarning   A message box containing a yellow exclamation point symbol.}
    20000..29999: MessageDlgPos(Messagestr,
        mtWarning,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
{mtError  A message box containing a red stop sign.}
    30000..40000: begin

        MessageDlgPos(Messagestr,
          mtError,
          [mbOK], {mbYesNoCancel,}
          HelpContextl,
          MessageX,
          MessageY);
      end;
  end;
end;
*)
{0000..9999 mtInformation	A message box containing a blue "i".
    9999: Messagestr := 'Resistance is futile'
      + #13#10 + 'All Messages end here';}
{10000..19999 mtConfirmation	A message box containing a green question mark.}
{20000..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
{30000..40000 mtError  A message box containing a red stop sign.
    30000: Messagestr := 'There is an Error in the system';
    30001: Messagestr := 'Voice failed without Registration'
               + #13#10 +'See About Register';
}

(*TMsgDlgBtn = (mbYes, mbNo, mbOK, mbCancel,
             mbAbort, mbRetry, mbIgnore,
             mbAll, mnNoToAll, mbYesToAll, mbHelp);
const
  mbYesNoCancel = [mbYes, mbNo, mbCancel];
  mbOKCancel = [mbOK, mbCancel];
  mbAbortRetryIgnore = [mbAbort, mbRetry, mbIgnore];

mbYes	A button with 'Yes' on its face.
mbNo	A button the text 'No' on its face.
mbOK	A button the text 'OK' on its face.
mbCancel	A button with the text 'Cancel' on its face.
mbAbort	A button with the text 'Abort' on its face
mbRetry	A button with the text 'Retry' on its face
mbIgnore	A button the text 'Ignore' on its face
mbAll	A button with the text 'All' on its face
mbNoToAll	A button with the text 'No to All' on its face
mbYesToAll	A button with the text 'Yes to All' on its face
mbHelp	A button with the text 'Help' on its face

RETURN VALUES
mrNone	 mrAbort	mrYes
mrOk	 mrRetry	mrNo
mrCancel mrIgnore	mrAll
*)
{---------------------------------------------------------------------}
(*      Begin
StrPCopy(s, 'DONE.WAV');
{Play the sound asynchronously}
sndPlaySound(s, 0); {see mmsystem.hlp for other values}
{
If you specify the SND_MEMORY flag, lpszSoundName must point to an
in-memory image of a waveform sound.
If the sound is stored as a resource, use
LoadResource and LockResource to load and lock the resource and get a
pointer to it.
}
       {setimage calls the ImageDone}
       {Whistle is a for i:= 100 do
       go up then down then around }
               { Beep( Pitch, Duration );}
{      Beep(1000,100);}{Order of units must make difference?}
      end;*)
      
end.
