{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LoCBitFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TCBitForm = class(TForm)
    CreateWidthEdit: TEdit;
    CreateHeightEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
procedure Initializer(Initializee:Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CBitForm: TCBitForm;
  InitialState:Integer;
implementation

{$R *.DFM}

uses AllShapeLoaderFrm, LoGlobals,LOResMess;

procedure TCBitForm.BitBtn3Click(Sender: TObject);
begin
  Application.HelpContext(13);
end;

procedure TCBitForm.FormCreate(Sender: TObject);
begin
  top := CBFY;
  left := CBFX;
  InitialState:=0;
end;

procedure TCBitForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CBFY := CBitForm.top;
  CBFX := CBitForm.left;
end;
procedure TCBitForm.Initializer(Initializee:Integer);
begin
If Initializee = 0 then
begin
InitialState:=Initializee;
CreateWidthEdit.Text:='';{ Inttostr(ScreenWidth); }{NewLayerName}
Label1.Caption:= 'Width';
CBitForm.Caption:= 'Create Bitmap';
Label2.Visible:=True;
CreateHeightEdit.Visible:=True;
Label2.Caption:= 'Height';
CreateHeightEdit.Text:='';{ Inttostr(ScreenHeight);}
end else
If Initializee = 1 then
begin
InitialState:=Initializee;
CreateWidthEdit.Text:= ShpFilename; {NewLayerName}
Label1.Caption:= 'New Layer Name';
CBitForm.Caption:= 'Create New Layer';
Label2.Visible:=False;
CreateHeightEdit.Visible:=False;
end;
end;
procedure TCBitForm.BitBtn1Click(Sender: TObject);
var Checker,Code,Code2:Integer;
begin
If InitialState = 1 then
Begin
  NewLayerName:=CreateWidthEdit.Text; {NewLayerName}
  CBitForm.ModalResult:=mrOK;
end else
If InitialState = 0 then
Begin
{Check StrToInt}
val(CreateWidthEdit.Text,Checker,Code);
If Code<>0 then Codefx(CreateWidthEdit.Text,Code)
   else If (Code=Checker)then Code:=1;
val(CreateHeightEdit.Text,Checker,Code2);
If Code2<>0 then Codefx(CreateHeightEdit.Text,Code2)
   else If (Code2=Checker)then Code2:=1;
If ( (Code<>0) or (Code2<>0 ) )then
  CBitForm.ModalResult:=mrNone
  else  CBitForm.ModalResult:=mrOK;
End else CBitForm.ModalResult:=mrNone;
end;

procedure TCBitForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var Checker,Code,Code2:Integer;
begin
If InitialState = 1 then
Begin
  NewLayerName:=CreateWidthEdit.Text; {NewLayerName}
  CanClose:=True;
end else
If InitialState = 0 then
Begin
{Check StrToInt}
val(CreateWidthEdit.Text,Checker,Code);
If Code<>0 then Codefx(CreateWidthEdit.Text,Code)
   else If (Code=Checker)then;
val(CreateHeightEdit.Text,Checker,Code2);
If Code2<>0 then Codefx(CreateHeightEdit.Text,Code2)
   else If (Code=Checker)then;
If ( (Code<>0) or (Code2<>0 ) )then
  CanClose:=False
  else  CanClose:=True;
end else  CanClose:=True;
end;

end.
